# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.
setwd("C:/TRI/exemplo")

# respostas so literais (A,B,C...) ou so numricas (corrigidas: 1=acerto, 0=erro)?
# Escolha "L" para literais ou "N" para numericas
tiporesposta<-"L"

############################################################################################
# Fase 1 - Anlise clssica dos itens de um teste Y
############################################################################################
### arquivo entraday.txt ###
# O arquivo que deseja realizar a anlise deve-se chamar 'entraday.txt' (tudo em minusculas)
# ao final ser gerado um arquivo chamado 'saida-fase1-x.txt' com os resultados da anlise e
# um histograma da distribuio dos escores chamado 'saida-fase1-hist-x.jpg'
# Configurao do arquivo 'entraday.txt':
# primeira linha = nome_do_gabarito,A,B,A,E,....
# segunda linha = nmero de alternativas da questo correspondente separado por ','
# terceira linha = S se o item deve ser considerado na anlise ou
#                  N se no deve ser considerado na anlise separado por ','
# USE SEMPRE LETRAS MAIUSCULAS para 'S' e 'N'
# quarta linha = nomes dos itens separados por vrgulas 
# demais linhas = respostas dos indivduos: primeira coluna  a identificao do 
# respondente e as demais colunas so as respostas, separadas por vrgulas.
# Nas respostas e no gabarito, as letras devem ser todas maisculas ou todas minsculas.
# Deve estar disponvel a biblioteca MASS e tcltk para que o programa rode.
# Restrio: o nmero mximo de alternativas por item  igual a 20.
# Anlise realizada considerando os itens dicotmicos (certo ou errado).
# Considera-se que as respostas provm de um nico grupo.
# Os resultados apresentados esto na forma de proporo.
############################################################################################
#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################


library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );


# provax = respostas
# infoprovax = informaes sobre nmero de itens, gabarito e analise

provax<-read.table("entraday.txt", header=TRUE, fill=TRUE, skip=3,sep=",")
infoprovax<-read.table("entraday.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")

NAX<-length(provax[,1])  # NAX = nmero de indivduos que realizaram o teste X

NIX<-length(infoprovax[1,])-1   # NIX = nmero de itens do teste X+V

respostax<-scan(file="entraday.txt", sep=",", what=list(""),n=length(infoprovax[1,]))
gabax<-respostax[[1]]  # vetor que contm o gabarito do teste X+V

respostax<-scan(file="entraday.txt", sep=",", skip=1, what=list(0),n=length(NIX))
alterx<-respostax[[1]]  # vetor que contm o nmero de alternativas por questo do teste X+V

respostax<-scan(file="entraday.txt", sep=",", skip=2, what=list(""),n=length(NIX))
considerax<-respostax[[1]]  # considera (S) ou desconsidera(N) o item

respostax<-scan(file="entraday.txt", sep=",", skip=3, what=list(""),n=length(NIX))
nomeitemx<-respostax[[1]]  # nomes dos itens

#
# transforma arquvio numrico em literal
#

if (tiporesposta=="N")
{

alterx<-rep(2,NIX)

# transforma 1 em A e 0 em B
NIXaux<-NIX+1
for (i in 2:NIXaux)
{
	if(gabax[i]=="1") {gabax[i]<-"A"}
	else {gabax[i]<-"B"}
}

for (j in 1:NIX)
{
	for (i in 1:NAX)
	{
		if(provax[i,j+1]==1) {provax[i,j+1]<-"A"}
		else {provax[i,j+1]<-"B"}
	}
}
}


### escores por indivduo ###
escorex<-matrix(nc=1, nr=NAX)  # escorex = escore dos indivduos do teste X+V
escorex[,1]<-0   #atribui escore inicial zero a todos respondentes 
NIXaux<-NIX+1    # contador auxiliar
for(contaluno in 1:NAX)
{
	for(contitens in 2:NIXaux)
	{
		if(considerax[contitens-1]=="S")
		{
			if(provax[contaluno,contitens]==gabax[contitens])
			{
				escorex[contaluno,1]<-escorex[contaluno,1]+1
			}
		}
	}
}


### alternativas possiveis ###
# limita o programa a no mximo 20 alternativas
alternativas<-c("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T")
if (max(alterx) > 20){
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO!
Nmero mximo de alternativas por item  igual 20!",icon="warning",type="ok")
print("*** ERRO: numero maximo de alternativas por item e' igual 20!")}

### cria vetor de posio das alternativas corretas
# posgaba = posio da alternativa correta
for (i in 2:NIXaux)
{
	for (j in 1:20)
	{
		if (gabax[i]==alternativas[j])
		{
			if (i==2) {posgaba<-c(j)}
			else {posgaba<-c(posgaba,j)}
		}
	}
}




### escores por indivduo ###
escorex<-matrix(nc=1, nr=NAX)  # escorex = escore dos indivduos do teste X+V
escorex[,1]<-0   #atribui escore inicial zero a todos respondentes 
NIXaux<-NIX+1    # contador auxiliar
for(contaluno in 1:NAX)
{
	for(contitens in 2:NIXaux)
	{
		if(considerax[contitens-1]=="S")
		{
			if(provax[contaluno,contitens]==gabax[contitens])
			{
				escorex[contaluno,1]<-escorex[contaluno,1]+1
			}
		}
	}
}


### alternativas possiveis ###
# limita o programa a no mximo 20 alternativas
alternativas<-c("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T")
if (max(alterx) > 20){print("*** ERRO: nmero mximo de alternativas por item  igual 20!")}

### cria vetor de posio das alternativas corretas
# posgaba = posio da alternativa correta
for (i in 2:NIXaux)
{
	for (j in 1:20)
	{
		if (gabax[i]==alternativas[j])
		{
			if (i==2) {posgaba<-c(j)}
			else {posgaba<-c(posgaba,j)}
		}
	}
}

### matriz que armazenar todos os clculos da matriz estatitem
estattotal<-matrix(nr=1, nc=4)
estatzero<-matrix(nr=1, nc=4) #matriz vazia apenas p/ serparar os dados


### gera matriz de 0 (erro) e 1 (acerto) para cada item
# contitens = posio do item na matrix provax
# conteitens2 = posio do item nas matrizes alterx e considerax


for (contitens in 2:NIXaux)
{
contitens2<-contitens-1
if (considerax[contitens2]=="S") 
{
	zeroumx<-matrix(nr=NAX, nc=alterx[contitens2]+1)
	for (contalter in 1:alterx[contitens2])
		{
		for(contaluno in 1:NAX)
			{
			if (alternativas[contalter]==provax[contaluno,contitens])
				{zeroumx[contaluno,contalter]<-1}
				else
				{zeroumx[contaluno,contalter]<-0}
			}
		}

	for(contaluno in 1:NAX)
		{
		soma<-0
		for (i in 1:contalter) 
		{soma<-soma+zeroumx[contaluno,i]}

		if (soma==0)
			{zeroumx[contaluno,contalter+1]<-1}
			else
			{zeroumx[contaluno,contalter+1]<-0}
		}
		
	
	
# dificuldade = ndice de dificuldade = proporo de acertos
numalter<-alterx[contitens2]+1  # nmero de alternativas do item A,B,C...,Outros
estatitem<-matrix(nc=4, nr=numalter)

for (i in 1:numalter)
	{
	estatitem[i,1]<-mean(zeroumx[,i])  # coluna 1 de estatitem = prop acerto = dificuldade
	}

# define as posies (alunos) do GS e GI
GI<-quantile(escorex[,1],0.27)
GS<-quantile(escorex[,1],0.73)
GIpos<-c(0)
GSpos<-c(0)
	for (i in 1:NAX)
	{
	if (escorex[i,1]<=GI)
		{
		if (GIpos[1]==0) 
		{
		GIpos<-c(i)
		maxGI<-escorex[i,1]   # escore max. do GI
		}
		else 
		{
		GIpos<-c(GIpos,i)
		if (escorex[i,1]>maxGI) {maxGI<-escorex[i,1]}
		}
		}
	if (escorex[i,1]>=GS)
		{
		if (GSpos[1]==0) 
		{
		GSpos<-c(i)
		minGS<-escorex[i,1]	# escore min. do GS
		}
		else 
		{
		GSpos<-c(GSpos,i)
		if (escorex[i,1]<minGS) {minGS<-escorex[i,1]}
		}
		}
	}

# calcula a proporao de acerto do GS e GI para cada alternativa

for(k in 1:numalter)
{
somaGI<-0
	for (i in 1:length(GIpos))
	{
	somaGI<-somaGI+zeroumx[GIpos[i],k]
	}
estatitem[k,2]<-somaGI/length(GIpos)

somaGS<-0
	for (i in 1:length(GSpos))
	{
	somaGS<-somaGS+zeroumx[GSpos[i],k]
	}
estatitem[k,3]<-somaGS/length(GSpos)
}



# cria vetor dos escores
escorevet<-c(escorex[,1])

# cria vetor temporrio (escorealt) de 0 e 1 p/ cada alternativa 
# e calcula o coef de correlao de Pearson entre
# os escores e cada uma das alternativas

for (k in 1:numalter)
	{
	escorealt<-c(zeroumx[,k])
	estatitem[k,4]<-cor(escorevet,escorealt, method=c("pearson"))
	}
estattotal<-rbind(estattotal,estatitem)
estattotal<-rbind(estattotal,estatzero) # linha separadora
}
}

# arredonda os valores de estattotal p/ 2 casas decimais
estattotal<-round(estattotal, digits=2)
# cria matriz cujos dados tem necessariamente 2 casas decimais
estatdec<-format(estattotal, digits=2, nsmall=2)


###
### cria matriz sada
###
saida<-matrix(nc=8, nr=1)
saida[1,1]<-"An. de itens"
saida[1,2]<-"Fase 1 "
saida[1,3]<-"Teste Y "

# cria contador para as linhas da matriz
# conttot = contador da matriz estattotal
conttot<-2

# faz a montagem da matriz sada para cada item
for (k in 1:NIX)
{
if (considerax[k]=="S") 
{
saidatemp<-matrix(nc=8, nr=alterx[k]+4)  #matriz temporria p/ compor a matriz saida
saidatemp[2,1]<-"ITEM:"
saidatemp[2,2]<-nomeitemx[k+1]
saidatemp[3,1]<-"Prop. corr.:"
poslin<-conttot+posgaba[k]-1  #define a posio do item correto na matriz estattotal
saidatemp[3,2]<-estatdec[poslin,1]
saidatemp[4,1]<-"Ind. discrim.:"
discrimina<-estattotal[poslin,3]-estattotal[poslin,2]
dec<-format(discrimina, nsmall=2, digits=2)
saidatemp[4,2]<-dec
saidatemp[5,1]<-"Pto. biss.:"
saidatemp[5,2]<-estatdec[poslin,4]
saidatemp[3,3]<-"Alter."
saidatemp[3,4]<-"Prop."
saidatemp[3,5]<-"GI"
saidatemp[3,6]<-"GS"
saidatemp[3,7]<-"Pto.biss."
saidatemp[3,8]<-"Gabarito"
saidatemp[posgaba[k]+3,8]<-"*"
for (i in 1:alterx[k])
	{
	saidatemp[i+3,3]<-alternativas[i]
	}
saidatemp[alterx[k]+4,3]<-"Outros"
nlinhas<-alterx[k]+1
for(i in 1:nlinhas)
	{
	conttot2<-conttot-1+i
	saidatemp[i+3,4]<-estatdec[conttot2,1]
	saidatemp[i+3,5]<-estatdec[conttot2,2]
	saidatemp[i+3,6]<-estatdec[conttot2,3]
	saidatemp[i+3,7]<-estatdec[conttot2,4]	
	}
conttot<-conttot+nlinhas+1  #atualiza posio na matriz estattotal
saida<-rbind(saida,saidatemp)

}
}

# nmero de itens descartados
contdescart<-0
for (i in 1:length(considerax))
{
if (considerax[i]=="N")
	{contdescart<-contdescart+1}
}
contconsid<-NIX-contdescart
saidatemp<-matrix(nc=8, nr=20)
saidatemp[3,1]<-"Estatisticas"
saidatemp[4,1]<-" do teste Y"
saidatemp[5,1]<-"============"
saidatemp[6,1]<-"N.itens"
saidatemp[6,2]<-contconsid
saidatemp[7,1]<-"N.descartados"
saidatemp[7,2]<-contdescart
saidatemp[8,1]<-"N.individuos"
saidatemp[8,2]<-NAX
saidatemp[9,1]<-"escore medio"
arred<-round(mean(escorex[,1]), digits=3)
saidatemp[9,2]<-format(arred, digits=3, nsmall=3)
saidatemp[10,1]<-"desvio-padrao"  # amostral
arred<-round(sqrt(var(escorex[,1])), digits=3)
saidatemp[10,2]<-format(arred, digits=3, nsmall=3)
saidatemp[11,1]<-"maximo"
saidatemp[11,2]<-format(max(escorex[,1]), digits=3, nsmall=3)
saidatemp[12,1]<-"minimo"
saidatemp[12,2]<-format(min(escorex[,1]), digits=3, nsmall=3)
saidatemp[13,1]<-"mediana"
saidatemp[13,2]<-format(median(escorex[,1]), digits=3, nsmall=3)

# calculo do alfa (coef. de fidedignidade do teste)
contestat<-1  # contador para matriz estattotal
somap<-0
for (i in 1:length(considerax))
{
if (considerax[i]=="S")
{
p<-estattotal[contestat+posgaba[i],1]
somap<-somap + p*(1-p)
contestat<-contestat+alterx[i]+2
}
}
alfa<-(contconsid/(contconsid-1))*(1-somap/var(escorex[,1]))
saidatemp[14,1]<-"ALFA"
saidatemp[14,2]<-format(alfa, digits=3, nsmall=3)

# calculo do EPM (erro padro de medida)
EPM<-sqrt(var(escorex[,1]))*sqrt(1-alfa)
saidatemp[15,1]<-"EPM"
saidatemp[15,2]<-format(EPM, digits=3, nsmall=3)

# grupos superiores e inferiores (GS e GI)
saidatemp[16,1]<-"num. indiv. GI"
saidatemp[16,2]<-length(GIpos)
saidatemp[17,1]<-"escore max. GI"
saidatemp[17,2]<-maxGI
saidatemp[18,1]<-"num. indiv. GS"
saidatemp[18,2]<-length(GSpos)
saidatemp[19,1]<-"escore min. GS"
saidatemp[19,2]<-minGS

# monta a matriz saida
saida<-rbind(saida,saidatemp)

# retira os NA da matriz saida
for (i in 1:length(saida[,1]))
{
	for (j in 1:length(saida[1,]))
	{
	if (is.na(saida[i,j])==TRUE)
		{
		saida[i,j]<-" "
		}
	}
}

tkdestroy(tela)

# gera arquivo final "saida-fase1-y.txt"
write.matrix(saida, file = "saida-fase1-y.txt", sep = " ")


# cria arquivo com um histograma dos escores

jpeg(filename = "saida-fase1-hist-y.jpg", width = 500, height = 500,pointsize = 12, quality = 75, bg = "white")

hist(escorex, main="Histograma dos escores Y", xlab="escores", ylab="frequencia")

dev.off()




# mensagem de alerta
ReturnVal <- tkmessageBox(title="Anlise de itens - teste Y",message="Os resultados da anlise esto nos arquivos 
saida-fase1-y.txt e 
saida-fase1-hist-y.jpg .",icon="info",type="ok")