# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.

setwd("C:/TRI/exemplo")


# Define se o teste ncora  interno (I) ou externo (E)
testeancora<-"I"

# atribui os pesos para as populaes sintticas

# w1 = peso para a populao X

# w2 = peso para a populao Y



w1<-1

w2<-1-w1

# respostas so literais (A,B,C...) ou esto numricas (corrigidas: 1=acerto, 0=erro)?
# Escolha "L" para literais ou "N" para numericas
tiporesposta<-"L"


############################################################################################
###	MTODO LINEAR DE BRAUN-HOLLAND - Equalizao clssica
############################################################################################

# Equalizao linear para grupos no equivalentes com teste ncora.
### arquivos entradax.txt e entraday.txt ###

# Os arquivos correspondentes aos testes X e Y devem-se chamar 'entradax.txt'

# e 'entraday.txt' (tudo em minusculas).
# A equalizao transforma os escores do teste X na escala do teste Y.

# Ao final ser gerado um arquivo chamado 'saida-fase2-BraunHol.txt' com os resultados 
# da anlise e um arquivo 'saida-fase2-graf-BraHol.jpg' com grficos de regresso.

# Configurao dos arquivos 'entradax.txt' e 'entraday.txt':

# primeira linha = nome do gabarito,A,B,D,E,....

# segunda linha = nmero de alternativas da questo correspondente separado por ','

# terceira linha = S se o item deve ser considerado na anlise ou

#                  N se no deve ser considerado na anlise separado por ','

# USE SEMPRE LETRAS MAIUSCULAS para 'S' e 'N'

# quarta linha = nomes dos itens separados por vrgulas. 

# ITENS COMUNS DEVEM TER O MESMO NOME!

# demais linhas = respostas dos indivduos: primeira coluna  a identificcao do 

# respondente e as demais colunas so as respostas, separados por vrgulas.

# Nas respostas e no gabarito, as letras devem ser todas maisculas ou todas minsculas.

# Deve estar disponvel a biblioteca MASS e tcltk para que o programa rode.

# Restrio: o nmero mximo de alternativas por item  igual a 20.

# Anlise realizada considerando os itens dicotmicos (certo ou errado).

# Os resultados apresentados esto na forma de proporo.

############################################################################################

#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################


library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );



# provax, provay = respostas

# infoprovax, infoprovay = informaes sobre nmero de itens, gabarito e analise



provax<-read.table("entradax.txt", header=TRUE, fill=TRUE, skip=3,sep=",")

infoprovax<-read.table("entradax.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")

provay<-read.table("entraday.txt", header=TRUE, fill=TRUE, skip=3,sep=",")

infoprovay<-read.table("entraday.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")



NAX<-length(provax[,1])  # NAX = nmero de indivduos que realizaram o teste X

NAY<-length(provay[,1])  # NAY = nmero de indivduos que realizaram o teste Y



NIX<-length(infoprovax[1,])-1   # NIX = nmero de itens do teste X+V

NIY<-length(infoprovay[1,])-1   # NIY = nmero de itens do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", what=list(""),n=length(infoprovax[1,]))

gabax<-respostax[[1]]  # vetor que contm o gabarito do teste X+V

respostay<-scan(file="entraday.txt", sep=",", what=list(""),n=length(infoprovay[1,]))

gabay<-respostay[[1]]  # vetor que contm o gabarito do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", skip=1, what=list(0),n=length(NIX))

alterx<-respostax[[1]]  # vetor que contm o nmero de alternativas por questo do teste X+V

respostay<-scan(file="entraday.txt", sep=",", skip=1, what=list(0),n=length(NIY))

altery<-respostay[[1]]  # vetor que contm o nmero de alternativas por questo do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", skip=2, what=list(""),n=length(NIX))

considerax<-respostax[[1]]  # considera (S) ou desconsidera (N) o item

respostay<-scan(file="entraday.txt", sep=",", skip=2, what=list(""),n=length(NIY))

consideray<-respostay[[1]]  # considera (S) ou desconsidera (N) o item



respostax<-scan(file="entradax.txt", sep=",", skip=3, what=list(""),n=length(NIX))

nomeitemx<-respostax[[1]]  # nomes dos itens

respostay<-scan(file="entraday.txt", sep=",", skip=3, what=list(""),n=length(NIY))

nomeitemy<-respostay[[1]]  # nomes dos itens



### escores por indivduo do teste total (comum+no comum) ###

escorex<-matrix(nc=3, nr=NAX)  # escorex = escore dos indivduos do teste X+V

escorex[,]<-0   #atribui escore inicial zero a todos respondentes 

NIXaux<-NIX+1    # contador auxiliar
numitensx<-0  # nmero de itens considerados no teste X

for(contaluno in 1:NAX)

{

	for(contitens in 2:NIXaux)

	{

		if(considerax[contitens-1]=="S")

		{

			if(provax[contaluno,contitens]==gabax[contitens])

			{

				escorex[contaluno,1]<-escorex[contaluno,1]+1

			}
		}

	}

}



escorey<-matrix(nc=3, nr=NAY)  # escorey = escore dos indivduos do teste Y+V

escorey[,]<-0   #atribui escore inicial zero a todos respondentes 

NIYaux<-NIY+1    # contador auxiliar
numitensy<-0  # nmero de itens considerados no teste Y

for(contaluno in 1:NAY)

{

	for(contitens in 2:NIYaux)

	{

		if(consideray[contitens-1]=="S")

		{

			if(provay[contaluno,contitens]==gabay[contitens])

			{

				escorey[contaluno,1]<-escorey[contaluno,1]+1

			}
		}

	}

}



if (tiporesposta=="L")
{

### alternativas possiveis ###

# limita o programa a no mximo 20 alternativas

alternativas<-c("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T")

if (max(alterx) > 20){
print("*** ERRO no teste X: numero maximo de alternativas por item e' igual 20!")
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO - teste X
Nmero mximo de alternativas por item  igual a 20!",icon="warning",type="ok")}

if (max(altery) > 20){
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO - teste Y
Nmero mximo de alternativas por item  igual a 20!",icon="warning",type="ok")
print("*** ERRO no teste Y: numero maximo de alternativas por item e' igual 20!")}

}


### localiza os itens comuns em cada uma das provas e cria vetor com essas posies

# poscomumx = posio dos itens comuns na prova x

# poscomumy = posio dos itens comuns na prova y



contcomum<-0  # conta o nmero de itens comuns



for (i in 2:NIXaux)

{

	for(j in 2:NIYaux)

	{

		if(nomeitemx[i]==nomeitemy[j])

		{
			if(considerax[i-1]=="S" & consideray[j-1]=="S")
			# considera que se um mesmo item for 'S' em um teste e 'N' em outro, 
			# o item no  comum
			{

				if(contcomum==0)

				{

				poscomumx<-c(i)

				poscomumy<-c(j)

				}

				else

				{

				poscomumx<-c(poscomumx,i)

				poscomumy<-c(poscomumy,j)

				}
				contcomum<-contcomum+1
			}

		}

	}

}

if (contcomum==0)

{

print("*** ERRO ***")

print("Nao foram encontrados itens comuns.")

print("Nao e' possivel realizar a equalizacao!")

print("Verifique se aos itens comuns foram atribuidos mesmo nome.")
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO!
No foram encontrados itens comuns.
No  possvel realizar a equalizao!
Verifique se aos itens comuns foram atribuidos mesmo nome.",icon="warning",type="ok")

}



### calcula escores por indivduos para as partes no comuns (s X e s Y) e 

### para as comuns (VX e VY) dos testes X e Y



# calculo dos escores da prova VX

for(contaluno in 1:NAX)

{

	for(i in 1:length(poscomumx))

	{

		if(considerax[poscomumx[i]-1]=="S")

		{

			if(provax[contaluno,poscomumx[i]]==gabax[poscomumx[i]])

			{

				escorex[contaluno,3]<-escorex[contaluno,3]+1

			}

		}

	}

}



# calculo dos escores da prova X (no comum)

for(contaluno in 1:NAX)

{

escorex[contaluno,2]<-escorex[contaluno,1]-escorex[contaluno,3]

}





# calculo dos escores da prova VY

for(contaluno in 1:NAY)

{

	for(i in 1:length(poscomumy))

	{

		if(consideray[poscomumy[i]-1]=="S")

		{

			if(provay[contaluno,poscomumy[i]]==gabay[poscomumy[i]])

			{

				escorey[contaluno,3]<-escorey[contaluno,3]+1

			}

		}

	}

}



# calculo dos escores da prova Y (no comum)

for(contaluno in 1:NAY)

{

escorey[contaluno,2]<-escorey[contaluno,1]-escorey[contaluno,3]

}



###

### Incio da equalizao 

### Mtodo: Braun-Holland

###

# contagem do nmero de itens considerados
numitensx<-0
for (i in 1:length(considerax))
{
	if(considerax[i]=="S")
	{
	numitensx<-numitensx+1
	}
}

numitensy<-0
for (i in 1:length(consideray))
{
	if(consideray[i]=="S")
	{
	numitensy<-numitensy+1
	}
}


contx<-numitensx-contcomum  #nmero de itens no comuns do teste X
conty<-numitensy-contcomum  #nmero de itens no comuns do teste Y

#################################
#
# TESTE ANCORA EXTERNO - INCIO
#
#################################

if (testeancora=="E")
{

### tabela A = f1(x,v) = conjunta de X e V
tabelaa<-matrix(nr=contx+2, nc=contcomum+3)
tabelaa[,]<-0
for (acertov in 0:contcomum)
{
	for(acertox in 0:contx)
	{
		for(i in 1:NAX)
		{
			if (escorex[i,2]==acertox & escorex[i,3]==acertov)
			{
			tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]+1
			}	
		}
	tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]/NAX
	}
}
# marginal: calculo de h1(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelaa[contx+2,i]<-sum(tabelaa[,i])
}

# marginal: calculo de f1(x) e F1(x)
contaux<-contx+1
for (i in 1:contaux)
{
tabelaa[i,contcomum+2]<-sum(tabelaa[i,])
tabelaa[i,contcomum+3]<-sum(tabelaa[,contcomum+2])
}


### tabela B = g2(y,v) = conjunta de Y e V
tabelab<-matrix(nr=conty+2, nc=contcomum+3)
tabelab[,]<-0
for (acertov in 0:contcomum)
{
	for(acertoy in 0:conty)
	{
		for(i in 1:NAY)
		{
			if (escorey[i,2]==acertoy & escorey[i,3]==acertov)
			{
			tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]+1
			}	
		}
	tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]/NAY
	}
}

# marginal: calculo de h2(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelab[conty+2,i]<-sum(tabelab[,i])
}

# marginal: calculo de g2(y) e G2(y)
contaux<-conty+1
for (i in 1:contaux)
{
tabelab[i,contcomum+2]<-sum(tabelab[i,])
tabelab[i,contcomum+3]<-sum(tabelab[,contcomum+2])
}

### tabela C = f1(x|v) = condicional de x dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)=0 e h2(v)>0, procura um valor maior que zero em v+1, v+2...
tabelac<-matrix(nc=contcomum+1, nr=contx+1)
contaux1<-contcomum+1
contaux2<-contx+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[contx+2,j]==0 & tabelab[conty+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[contx+2,j]==0 & tabelab[conty+2,j]>0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelaa[contx+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelaa[contx+2,k]==0)
			{
				k<-j
				while (tabelaa[contx+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelac[i,j]<-tabelaa[i,k]/tabelaa[contx+2,k]		
		}
		if (tabelaa[contx+2,j]>0)
		{		
			tabelac[i,j]<-tabelaa[i,j]/tabelaa[contx+2,j]
		}
	}
}

### tabela D = g2(y|v) = condicional de y dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)>0 e h2(v)=0, procura um valor maior que zero em v+1, v+2...
tabelad<-matrix(nc=contcomum+1, nr=conty+1)
contaux1<-contcomum+1
contaux2<-conty+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[contx+2,j]==0 & tabelab[conty+2,j]==0)
		{
			tabelad[i,j]<-0
		}
		if (tabelaa[contx+2,j]>0 & tabelab[conty+2,j]==0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelab[conty+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelab[conty+2,k]==0)
			{
				k<-j
				while (tabelab[conty+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelad[i,j]<-tabelab[i,k]/tabelab[conty+2,k]		
		}
		if (tabelab[conty+2,j]>0)
		{		
			tabelad[i,j]<-tabelab[i,j]/tabelab[conty+2,j]
		}
	}
}

### tabela E = f1(x|v)*h2(v)
tabelae<-matrix(nc=contcomum+3, nr=contx+1)
tabelae[,]<-0
contaux1<-contcomum+1
contaux2<-contx+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelae[i,j]<-tabelac[i,j]*tabelaa[contx+2,j]
	}
	tabelae[i,contcomum+2]<-sum(tabelae[i,])
	tabelae[i,contcomum+3]<-sum(tabelae[,contcomum+2])
}



### tabela F = g2(y|v)*h1(v)
tabelaf<-matrix(nc=contcomum+3, nr=conty+1)
tabelaf[,]<-0
contaux1<-contcomum+1
contaux2<-conty+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelaf[i,j]<-tabelad[i,j]*tabelab[conty+2,j]
	}
	tabelaf[i,contcomum+2]<-sum(tabelaf[i,])
	tabelaf[i,contcomum+3]<-sum(tabelaf[,contcomum+2])
}


### tabela L: fs(x) - pop. sintetica
tabelal<-matrix(nc=5, nr=contx+1)
contxaux<-contx+1
tabelal[,1]<-seq(0,contx,1)  # escores de x
for (i in 1:contxaux)
{
tabelal[i,2]<-w1*tabelaa[i,contcomum+2]+w2*tabelae[i,contcomum+2]
tabelal[i,3]<-tabelal[i,2]*tabelal[i,1]
}
mediax<-sum(tabelal[,3])  # media da pop. sintetica X
for (i in 1:contxaux)
{
tabelal[i,4]<-((tabelal[i,1]-mediax)^2)*tabelal[i,2]
}
dpx<-sqrt(sum(tabelal[,4]))  # desvio padro da pop. sintetica X

### tabela M: gs(y) - pop. sintetica
tabelam<-matrix(nc=4, nr=conty+1)
contyaux<-conty+1
tabelam[,1]<-seq(0,conty,1)  # escores de y
for (i in 1:contyaux)
{
tabelam[i,2]<-w1*tabelaf[i,contcomum+2]+w2*tabelab[i,contcomum+2]
tabelam[i,3]<-tabelam[i,2]*tabelam[i,1]
}
mediay<-sum(tabelam[,3])  # media da pop. sintetica Y
for (i in 1:contyaux)
{
tabelam[i,4]<-((tabelam[i,1]-mediay)^2)*tabelam[i,2]
}
dpy<-sqrt(sum(tabelam[,4]))  # desvio padrao da pop. sintetica Y

}

#################################
#
# TESTE ANCORA EXTERNO - FIM
#
#################################


#################################
#
# TESTE ANCORA INTERNO - INCIO
#
#################################
if (testeancora=="I")
{


### tabela A = f1(x,v) = conjunta de X e V
tabelaa<-matrix(nr=numitensx+2, nc=contcomum+3)
tabelaa[,]<-0
for (acertov in 0:contcomum)
{
	for(acertox in 0:numitensx)
	{
		for(i in 1:NAX)
		{
			if (escorex[i,1]==acertox & escorex[i,3]==acertov)
			{
			tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]+1
			}	
		}
	tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]/NAX
	}
}
# marginal: calculo de h1(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelaa[numitensx+2,i]<-sum(tabelaa[,i])
}

# marginal: calculo de f1(x) e F1(x)
contaux<-numitensx+1
for (i in 1:contaux)
{
tabelaa[i,contcomum+2]<-sum(tabelaa[i,])
tabelaa[i,contcomum+3]<-sum(tabelaa[,contcomum+2])
}


### tabela B = g2(y,v) = conjunta de Y e V
tabelab<-matrix(nr=numitensy+2, nc=contcomum+3)
tabelab[,]<-0
for (acertov in 0:contcomum)
{
	for(acertoy in 0:numitensy)
	{
		for(i in 1:NAY)
		{
			if (escorey[i,1]==acertoy & escorey[i,3]==acertov)
			{
			tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]+1
			}	
		}
	tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]/NAY
	}
}

# marginal: calculo de h2(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelab[numitensy+2,i]<-sum(tabelab[,i])
}

# marginal: calculo de g2(y) e G2(y)
contaux<-numitensy+1
for (i in 1:contaux)
{
tabelab[i,contcomum+2]<-sum(tabelab[i,])
tabelab[i,contcomum+3]<-sum(tabelab[,contcomum+2])
}

### tabela C = f1(x|v) = condicional de x dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)=0 e h2(v)>0, procura um valor maior que zero em v+1, v+2...
tabelac<-matrix(nc=contcomum+1, nr=numitensx+1)
contaux1<-contcomum+1
contaux2<-numitensx+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[numitensx+2,j]==0 & tabelab[numitensy+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[numitensx+2,j]==0 & tabelab[numitensy+2,j]>0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelaa[numitensx+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelaa[numitensx+2,k]==0)
			{
				k<-j
				while (tabelaa[numitensx+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelac[i,j]<-tabelaa[i,k]/tabelaa[numitensx+2,k]		
		}
		if (tabelaa[numitensx+2,j]>0)
		{		
			tabelac[i,j]<-tabelaa[i,j]/tabelaa[numitensx+2,j]
		}
	}
}

### tabela D = g2(y|v) = condicional de y dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)>0 e h2(v)=0, procura um valor maior que zero em v+1, v+2...
tabelad<-matrix(nc=contcomum+1, nr=numitensy+1)
contaux1<-contcomum+1
contaux2<-numitensy+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[numitensx+2,j]==0 & tabelab[numitensy+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[numitensx+2,j]>0 & tabelab[numitensy+2,j]==0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelab[numitensy+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelab[numitensy+2,k]==0)
			{
				k<-j
				while (tabelab[numitensy+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelad[i,j]<-tabelab[i,k]/tabelab[numitensy+2,k]		
		}
		if (tabelab[numitensy+2,j]>0)
		{		
			tabelad[i,j]<-tabelab[i,j]/tabelab[numitensy+2,j]
		}
	}
}

### tabela E = f1(x|v)*h2(v)
tabelae<-matrix(nc=contcomum+3, nr=numitensx+1)
tabelae[,]<-0
contaux1<-contcomum+1
contaux2<-numitensx+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelae[i,j]<-tabelac[i,j]*tabelaa[numitensx+2,j]
	}
	tabelae[i,contcomum+2]<-sum(tabelae[i,])
	tabelae[i,contcomum+3]<-sum(tabelae[,contcomum+2])
}


### tabela F = g2(y|v)*h1(v)
tabelaf<-matrix(nc=contcomum+3, nr=numitensy+1)
tabelaf[,]<-0
contaux1<-contcomum+1
contaux2<-numitensy+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelaf[i,j]<-tabelad[i,j]*tabelab[numitensy+2,j]
	}
	tabelaf[i,contcomum+2]<-sum(tabelaf[i,])
	tabelaf[i,contcomum+3]<-sum(tabelaf[,contcomum+2])
}


### tabela L: fs(x) - pop. sintetica
tabelal<-matrix(nc=5, nr=numitensx+1)
contxaux<-numitensx+1
tabelal[,1]<-seq(0,numitensx,1)  # escores de x
for (i in 1:contxaux)
{
tabelal[i,2]<-w1*tabelaa[i,contcomum+2]+w2*tabelae[i,contcomum+2]
tabelal[i,3]<-tabelal[i,2]*tabelal[i,1]
}
mediax<-sum(tabelal[,3])  # media da pop. sintetica X
for (i in 1:contxaux)
{
tabelal[i,4]<-((tabelal[i,1]-mediax)^2)*tabelal[i,2]
}
dpx<-sqrt(sum(tabelal[,4]))  # desvio padro da pop. sintetica X

### tabela M: gs(y) - pop. sintetica
tabelam<-matrix(nc=4, nr=numitensy+1)
contyaux<-numitensy+1
tabelam[,1]<-seq(0,numitensy,1)  # escores de y
for (i in 1:contyaux)
{
tabelam[i,2]<-w1*tabelaf[i,contcomum+2]+w2*tabelab[i,contcomum+2]
tabelam[i,3]<-tabelam[i,2]*tabelam[i,1]
}
mediay<-sum(tabelam[,3])  # media da pop. sintetica Y
for (i in 1:contyaux)
{
tabelam[i,4]<-((tabelam[i,1]-mediay)^2)*tabelam[i,2]
}
dpy<-sqrt(sum(tabelam[,4]))  # desvio padrao da pop. sintetica Y
}

#################################
#
# TESTE ANCORA INTERNO - FIM
#
#################################



### Equaao de Equalizaao: ly(x)=ax+b
a<-dpy/dpx
b<-mediay-dpy/dpx*mediax
for (i in 1:length(tabelal[,1]))
{
tabelal[i,5]<-a*tabelal[i,1]+b
}



# monta a matriz saida

saidabh<-matrix(nc=3, nr=31)
saidabh[1,1]<-"Metodo de"
saidabh[2,1]<-"Braun-Holland"
saidabh[3,1]<-"============="
saidabh[5,1]<-"Teste ancora:"
if (testeancora=="E")
{saidabh[5,2]<-"Externo"}
if (testeancora=="I")
{saidabh[5,2]<-"Interno"}
saidabh[7,1]<-"Pesos pop. sintet."
saidabh[8,1]<-"w1:"
saidabh[8,2]<-w1
saidabh[9,1]<-"w2:"
saidabh[9,2]<-w2

saidabh[10,1]<-"Itens consider. X:"
saidabh[10,2]<-numitensx
saidabh[11,1]<-"Itens descart. X:"
saidabh[11,2]<-NIX-numitensx

saidabh[12,1]<-"Itens consider. Y:"
saidabh[12,2]<-numitensy
saidabh[13,1]<-"Itens descart. Y:"
saidabh[13,2]<-NIY-numitensy

saidabh[14,1]<-"Num. itens comuns:"
saidabh[14,2]<-contcomum


saidabh[16,1]<-"Estatisticas"
saidabh[17,1]<-"------------"
saidabh[18,1]<-"media X: "
saidabh[18,2]<-format(mediax, digits=3, nsmall=3)
saidabh[19,1]<-"media Y: "
saidabh[19,2]<-format(mediay, digits=3, nsmall=3)
saidabh[20,1]<-"desvio-padrao X:"
saidabh[20,2]<-format(dpx, digits=3, nsmall=3)
saidabh[21,1]<-"desvio-padrao Y:"
saidabh[21,2]<-format(dpy, digits=3, nsmall=3)

saidabh[23,1]<-"Modelo de equaliz.: "
saidabh[24,1]<-"------------------- "
saidabh[25,2]<-"ly(x) = Ax + B"
saidabh[26,1]<-"A (inclinacao):"
saidabh[26,2]<-format(a, digits=3, nsmall=3)
saidabh[27,1]<-"B (intercepto):"
saidabh[27,2]<-format(b, digits=3, nsmall=3)



saidabh[29,1]<-"Escores equalizados"
saidabh[30,1]<-"-------------------"
saidabh[31,1]<-"escore x"
saidabh[31,2]<-"lY(x)"

# trunca escores fora dos limites mximo / mnimo
for (i in 1:nrow(tabelal))
{
	if(tabelal[i,5]<0) {tabelal[i,5]<-0}
	if(tabelal[i,5]>numitensy && testeancora=="I") {tabelal[i,5]<-numitensy}
	if(tabelal[i,5]>conty && testeancora=="E") {tabelal[i,5]<-conty}
}


saidabhaux<-matrix(nc=3, nr=length(tabelal[,1]))
saidabhaux[,1]<-tabelal[,1]
saidabhaux[,2]<-format(tabelal[,5], digits=3, nsmall=3)

saidabh<-rbind(saidabh,saidabhaux)



# retira os NA da matriz saida

for (i in 1:length(saidabh[,1]))

{

	for (j in 1:length(saidabh[1,]))

	{

	if (is.na(saidabh[i,j])==TRUE)

		{

		saidabh[i,j]<-" "

		}

	}

}

tkdestroy(tela)



# gera arquivo final "saida-fase2-BraunHol.txt"

write.matrix(saidabh, file = "saida-fase2-BraunHol.txt", sep = " ")

# gera as regresses de X em V e de Y em V
x1<-escorex[,1]
v1<-escorex[,3]
y2<-escorey[,1]
v2<-escorey[,3]
regx<-lm(x1~v1)
regy<-lm(y2~v2)

# cria arquivo com os grficos de regresso e resduos

jpeg(filename = "saida-fase2-graf-BraHol.jpg", width = 500, height = 500,pointsize = 12, quality = 75, bg = "white")

par(mfcol=c(2,2))
plot(v1,x1,xlab="escores teste V", ylab="escores teste X", main="Regresso de X em V")
abline(regx)
plot(residuals(regx),  xlab="Individuos", ylab="Residuos", main="Residuos de X em V")
plot(v2,y2,xlab="escores teste V", ylab="escores teste Y", main="Regresso de Y em V")
abline(regy)
plot(residuals(regy), xlab="Individuos", ylab="Residuos", main="Residuos de Y em V")

dev.off()


# mensagem de alerta
ReturnVal <- tkmessageBox(title="Equalizao clssica - Braun-Holland",message="Os resultados da anlise esto nos arquivos 
saida-fase2-BraunHol.txt e 
saida-fase2-graf-BraHol.jpg .",icon="info",type="ok")


