# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.

setwd("C:/TRI/exemplo")


# Define se o teste ncora  interno (I) ou externo (E)
testeancora<-"I"

# respostas so literais (A,B,C...) ou esto numricas (corrigidas: 1=acerto, 0=erro)?
# Escolha "L" para literais ou "N" para numericas
tiporesposta<-"L"


############################################################################################
###	MTODO EQUIPERCENTIL - Equalizao clssica
############################################################################################

# Equalizao linear para grupos no equivalentes com teste ncora.
### arquivos entradax.txt e entraday.txt ###

# Os arquivos correspondentes aos testes X e Y devem-se chamar 'entradax.txt'

# e 'entraday.txt' (tudo em minusculas).
# A equalizao transforma os escores do teste X na escala do teste Y.

# Ao final ser gerado um arquivo chamado 'saida-fase2-Equipercentil.txt' com os resultados 
# da anlise.

# Configurao dos arquivos 'entradax.txt' e 'entraday.txt':

# primeira linha = nome do gabarito,A,B,D,E,....

# segunda linha = nmero de alternativas da questo correspondente separado por ','

# terceira linha = S se o item deve ser considerado na anlise ou

#                  N se no deve ser considerado na anlise separado por ','

# USE SEMPRE LETRAS MAIUSCULAS para 'S' e 'N'

# quarta linha = nomes dos itens separados por vrgulas. 

# ITENS COMUNS DEVEM TER O MESMO NOME!

# demais linhas = respostas dos indivduos: primeira coluna  a identificcao do 

# respondente e as demais colunas so as respostas, separados por vrgulas.

# Nas respostas e no gabarito, as letras devem ser todas maisculas ou todas minsculas.

# Deve estar disponvel a biblioteca MASS e tcltk para que o programa rode.

# Restrio: o nmero mximo de alternativas por item  igual a 20.

# Anlise realizada considerando os itens dicotmicos (certo ou errado).

# Os resultados apresentados esto na forma de proporo.

############################################################################################

#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################


library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );



# provax, provay = respostas

# infoprovax, infoprovay = informaes sobre nmero de itens, gabarito e analise



provax<-read.table("entradax.txt", header=TRUE, fill=TRUE, skip=3,sep=",")

infoprovax<-read.table("entradax.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")

provay<-read.table("entraday.txt", header=TRUE, fill=TRUE, skip=3,sep=",")

infoprovay<-read.table("entraday.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")



NAX<-length(provax[,1])  # NAX = nmero de indivduos que realizaram o teste X

NAY<-length(provay[,1])  # NAY = nmero de indivduos que realizaram o teste Y



NIX<-length(infoprovax[1,])-1   # NIX = nmero de itens do teste X+V

NIY<-length(infoprovay[1,])-1   # NIY = nmero de itens do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", what=list(""),n=length(infoprovax[1,]))

gabax<-respostax[[1]]  # vetor que contm o gabarito do teste X+V

respostay<-scan(file="entraday.txt", sep=",", what=list(""),n=length(infoprovay[1,]))

gabay<-respostay[[1]]  # vetor que contm o gabarito do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", skip=1, what=list(0),n=length(NIX))

alterx<-respostax[[1]]  # vetor que contm o nmero de alternativas por questo do teste X+V

respostay<-scan(file="entraday.txt", sep=",", skip=1, what=list(0),n=length(NIY))

altery<-respostay[[1]]  # vetor que contm o nmero de alternativas por questo do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", skip=2, what=list(""),n=length(NIX))

considerax<-respostax[[1]]  # considera (S) ou desconsidera (N) o item

respostay<-scan(file="entraday.txt", sep=",", skip=2, what=list(""),n=length(NIY))

consideray<-respostay[[1]]  # considera (S) ou desconsidera (N) o item



respostax<-scan(file="entradax.txt", sep=",", skip=3, what=list(""),n=length(NIX))

nomeitemx<-respostax[[1]]  # nomes dos itens

respostay<-scan(file="entraday.txt", sep=",", skip=3, what=list(""),n=length(NIY))

nomeitemy<-respostay[[1]]  # nomes dos itens



### escores por indivduo do teste total (comum+no comum) ###

escorex<-matrix(nc=3, nr=NAX)  # escorex = escore dos indivduos do teste X+V

escorex[,]<-0   #atribui escore inicial zero a todos respondentes 

NIXaux<-NIX+1    # contador auxiliar
numitensx<-0  # nmero de itens considerados no teste X

for(contaluno in 1:NAX)

{

	for(contitens in 2:NIXaux)

	{

		if(considerax[contitens-1]=="S")

		{

			if(provax[contaluno,contitens]==gabax[contitens])

			{

				escorex[contaluno,1]<-escorex[contaluno,1]+1

			}
		}

	}

}



escorey<-matrix(nc=3, nr=NAY)  # escorey = escore dos indivduos do teste Y+V

escorey[,]<-0   #atribui escore inicial zero a todos respondentes 

NIYaux<-NIY+1    # contador auxiliar
numitensy<-0  # nmero de itens considerados no teste Y

for(contaluno in 1:NAY)

{

	for(contitens in 2:NIYaux)

	{

		if(consideray[contitens-1]=="S")

		{

			if(provay[contaluno,contitens]==gabay[contitens])

			{

				escorey[contaluno,1]<-escorey[contaluno,1]+1

			}
		}

	}

}


if (tiporesposta=="L")
{

### alternativas possiveis ###

# limita o programa a no mximo 20 alternativas

alternativas<-c("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T")

if (max(alterx) > 20){
print("*** ERRO no teste X: numero maximo de alternativas por item e' igual 20!")
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO - teste X
Nmero mximo de alternativas por item  igual a 20!",icon="warning",type="ok")}

if (max(altery) > 20){
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO - teste Y
Nmero mximo de alternativas por item  igual a 20!",icon="warning",type="ok")
print("*** ERRO no teste Y: numero maximo de alternativas por item e' igual 20!")}

}


### localiza os itens comuns em cada uma das provas e cria vetor com essas posies

# poscomumx = posio dos itens comuns na prova x

# poscomumy = posio dos itens comuns na prova y



contcomum<-0  # conta o nmero de itens comuns



for (i in 2:NIXaux)

{

	for(j in 2:NIYaux)

	{

		if(nomeitemx[i]==nomeitemy[j])

		{
			if(considerax[i-1]=="S" & consideray[j-1]=="S")
			# considera que se um mesmo item for 'S' em um teste e 'N' em outro, 
			# o item no  comum
			{

				if(contcomum==0)

				{

				poscomumx<-c(i)

				poscomumy<-c(j)

				}

				else

				{

				poscomumx<-c(poscomumx,i)

				poscomumy<-c(poscomumy,j)

				}
				contcomum<-contcomum+1
			}

		}

	}

}

if (contcomum==0)

{

print("*** ERRO ***")

print("Nao foram encontrados itens comuns.")

print("Nao e' possivel realizar a equalizacao!")

print("Verifique se aos itens comuns foram atribuidos mesmo nome.")
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO!
No foram encontrados itens comuns.
No  possvel realizar a equalizao!
Verifique se aos itens comuns foram atribuidos mesmo nome.",icon="warning",type="ok")

}



### calcula escores por indivduos para as partes no comuns (s X e s Y) e 

### para as comuns (VX e VY) dos testes X e Y



# calculo dos escores da prova VX

for(contaluno in 1:NAX)

{

	for(i in 1:length(poscomumx))

	{

		if(considerax[poscomumx[i]-1]=="S")

		{

			if(provax[contaluno,poscomumx[i]]==gabax[poscomumx[i]])

			{

				escorex[contaluno,3]<-escorex[contaluno,3]+1

			}

		}

	}

}



# calculo dos escores da prova X (no comum)

for(contaluno in 1:NAX)

{

escorex[contaluno,2]<-escorex[contaluno,1]-escorex[contaluno,3]

}





# calculo dos escores da prova VY

for(contaluno in 1:NAY)

{

	for(i in 1:length(poscomumy))

	{

		if(consideray[poscomumy[i]-1]=="S")

		{

			if(provay[contaluno,poscomumy[i]]==gabay[poscomumy[i]])

			{

				escorey[contaluno,3]<-escorey[contaluno,3]+1

			}

		}

	}

}



# calculo dos escores da prova Y (no comum)

for(contaluno in 1:NAY)

{

escorey[contaluno,2]<-escorey[contaluno,1]-escorey[contaluno,3]

}



###

### Incio da equalizao 

### Mtodo: Equipercentil

###

# contagem do nmero de itens considerados
numitensx<-0
for (i in 1:length(considerax))
{
	if(considerax[i]=="S")
	{
	numitensx<-numitensx+1
	}
}

numitensy<-0
for (i in 1:length(consideray))
{
	if(consideray[i]=="S")
	{
	numitensy<-numitensy+1
	}
}


contx<-numitensx-contcomum  #nmero de itens no comuns do teste X
conty<-numitensy-contcomum  #nmero de itens no comuns do teste Y

#################################
#
# TESTE ANCORA EXTERNO - INCIO
#
#################################

if (testeancora=="E")
{

### tabela A = f1(x,v) = conjunta de X e V
tabelaa<-matrix(nr=contx+2, nc=contcomum+3)
tabelaa[,]<-0
for (acertov in 0:contcomum)
{
	for(acertox in 0:contx)
	{
		for(i in 1:NAX)
		{
			if (escorex[i,2]==acertox & escorex[i,3]==acertov)
			{
			tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]+1
			}	
		}
	tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]/NAX
	}
}
# marginal: calculo de h1(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelaa[contx+2,i]<-sum(tabelaa[,i])
}

# marginal: calculo de f1(x) e F1(x)
contaux<-contx+1
for (i in 1:contaux)
{
tabelaa[i,contcomum+2]<-sum(tabelaa[i,])
tabelaa[i,contcomum+3]<-sum(tabelaa[,contcomum+2])
}


### tabela B = g2(y,v) = conjunta de Y e V
tabelab<-matrix(nr=conty+2, nc=contcomum+3)
tabelab[,]<-0
for (acertov in 0:contcomum)
{
	for(acertoy in 0:conty)
	{
		for(i in 1:NAY)
		{
			if (escorey[i,2]==acertoy & escorey[i,3]==acertov)
			{
			tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]+1
			}	
		}
	tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]/NAY
	}
}

# marginal: calculo de h2(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelab[conty+2,i]<-sum(tabelab[,i])
}

# marginal: calculo de g2(y) e G2(y)
contaux<-conty+1
for (i in 1:contaux)
{
tabelab[i,contcomum+2]<-sum(tabelab[i,])
tabelab[i,contcomum+3]<-sum(tabelab[,contcomum+2])
}

### tabela C = f1(x|v) = condicional de x dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)=0 e h2(v)>0, procura um valor maior que zero em v+1, v+2...
tabelac<-matrix(nc=contcomum+1, nr=contx+1)
contaux1<-contcomum+1
contaux2<-contx+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[contx+2,j]==0 & tabelab[conty+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[contx+2,j]==0 & tabelab[conty+2,j]>0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelaa[contx+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelaa[contx+2,k]==0)
			{
				k<-j
				while (tabelaa[contx+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelac[i,j]<-tabelaa[i,k]/tabelaa[contx+2,k]		
		}
		if (tabelaa[contx+2,j]>0)
		{		
			tabelac[i,j]<-tabelaa[i,j]/tabelaa[contx+2,j]
		}
	}
}

### tabela D = g2(y|v) = condicional de y dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)>0 e h2(v)=0, procura um valor maior que zero em v+1, v+2...
tabelad<-matrix(nc=contcomum+1, nr=conty+1)
contaux1<-contcomum+1
contaux2<-conty+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[contx+2,j]==0 & tabelab[conty+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[contx+2,j]>0 & tabelab[conty+2,j]==0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelab[conty+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelab[conty+2,k]==0)
			{
				k<-j
				while (tabelab[conty+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelad[i,j]<-tabelab[i,k]/tabelab[conty+2,k]		
		}
		if (tabelab[conty+2,j]>0)
		{		
			tabelad[i,j]<-tabelab[i,j]/tabelab[conty+2,j]
		}
	}
}

### tabela E = f1(x|v)*h2(v)
tabelae<-matrix(nc=contcomum+3, nr=contx+1)
tabelae[,]<-0
contaux1<-contcomum+1
contaux2<-contx+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelae[i,j]<-tabelac[i,j]*tabelaa[contx+2,j]
	}
	tabelae[i,contcomum+2]<-sum(tabelae[i,])
	tabelae[i,contcomum+3]<-sum(tabelae[,contcomum+2])
}


### tabela F = g2(y|v)*h1(v)
tabelaf<-matrix(nc=contcomum+3, nr=conty+1)
tabelaf[,]<-0
contaux1<-contcomum+1
contaux2<-conty+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelaf[i,j]<-tabelad[i,j]*tabelab[conty+2,j]
	}
	tabelaf[i,contcomum+2]<-sum(tabelaf[i,])
	tabelaf[i,contcomum+3]<-sum(tabelaf[,contcomum+2])
}


### tabela G = distr. acumuladas & rank percentil do teste X
### teste ncora EXTERNO
tabelag<-matrix(nc=9, nr=contx+1)
nr<-contx+1
for (i in 1:nr)
{
	tabelag[i,1]<-i-1
}
tabelag[,2]<-tabelae[,contcomum+2]
tabelag[,3]<-tabelae[,contcomum+3]
tabelag[1,4]<-tabelag[1,2]/2
for (i in 2:nr)
{
	tabelag[i,4]<-tabelag[i-1,3]+tabelag[i,2]/2
}

### tabela H = distr. acumuladas & rank percentil do teste Y
### teste ncora EXTERNO
tabelah<-matrix(nc=4, nr=conty+1)
nr<-conty+1
for (i in 1:nr)
{
	tabelah[i,1]<-i-1
}
tabelah[,2]<-tabelaf[,contcomum+2]
tabelah[,3]<-tabelaf[,contcomum+3]
tabelah[1,4]<-tabelah[1,2]/2
for (i in 2:nr)
{
	tabelah[i,4]<-tabelah[i-1,3]+tabelah[i,2]/2
}

### clculo de y* (tabela G)
nr<-contx+1
for (i in 1:nr)
{
	k<-1  #contador para o nmero de linhas

	while (tabelag[i,4]>=tabelah[k,3] && k<nrow(tabelah))
	{
		k<-k+1
	}
	if(k==nrow(tabelah))
	{
	if(tabelag[i,4]<tabelah[k,3]){tabelag[i,5]<-k-1}
	if(tabelag[i,4]>=tabelah[k,3]){tabelag[i,5]<-k}
	}
	else
	{
	tabelag[i,5]<-k-1    # k-1 = escore correspondente a y*
	}
}



### clculo de y** (tabela G)
for (i in 1:nr)
{
	k<-conty+1  #contador para o nmero de linhas
	if (tabelag[i,4]<=tabelah[1,3])
	{tabelag[i,6]<-(-1)}
	else
	{
		while (tabelag[i,4]<=tabelah[k,3])
		{
			k<-k-1
		}
		tabelag[i,6]<-k-1    # k-1 = escore correspondente a y**
	}
}

### clculo de ey*(x) (tabela G)
for (i in 1:nr)
{
k<-tabelag[i,5]
if(tabelag[i,4]==1)
	{tabelag[i,7]<-conty+0.5}
else
{
	if (k==0)
	{
	tabelag[i,7]<-(tabelag[i,4])/(tabelah[k+1,3])+k-0.5
	}
	else
	{
	tabelag[i,7]<-(tabelag[i,4]-tabelah[k,3])/(tabelah[k+1,3]-tabelah[k,3])+k-0.5
	}
}
}

### clculo de ey**(x) (tabela G)
for (i in 1:nr)
{
k<-tabelag[i,6]
if(tabelag[i,4]==0)
	{tabelag[i,8]<-(-0.5)}
else
{
	if (k==-1)
	{
	tabelag[i,8]<-(tabelag[i,4])/(tabelah[k+2,3])+k+0.5
	}
	else
	{
	if(k==nrow(tabelah)-1)
	{
	tabelag[i,8]<-tabelag[i,7]
	}
	else
	{
	tabelag[i,8]<-(tabelag[i,4]-tabelah[k+1,3])/(tabelah[k+2,3]-tabelah[k+1,3])+k+0.5
	}
	}
}
}

### clculo da mdia de ey*(x) e ey**(x) (tabela G)
for (i in 1:nr)
{
	tabelag[i,9]<-(tabelag[i,7]+tabelag[i,8])/2
}
}

#################################
#
# TESTE ANCORA EXTERNO - FIM
#
#################################


#################################
#
# TESTE ANCORA INTERNO - INCIO
#
#################################
if (testeancora=="I")
{


### tabela A = f1(x,v) = conjunta de X e V
tabelaa<-matrix(nr=numitensx+2, nc=contcomum+3)
tabelaa[,]<-0
for (acertov in 0:contcomum)
{
	for(acertox in 0:numitensx)
	{
		for(i in 1:NAX)
		{
			if (escorex[i,1]==acertox & escorex[i,3]==acertov)
			{
			tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]+1
			}	
		}
	tabelaa[acertox+1,acertov+1]<-tabelaa[acertox+1,acertov+1]/NAX
	}
}
# marginal: calculo de h1(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelaa[numitensx+2,i]<-sum(tabelaa[,i])
}

# marginal: calculo de f1(x) e F1(x)
contaux<-numitensx+1
for (i in 1:contaux)
{
tabelaa[i,contcomum+2]<-sum(tabelaa[i,])
tabelaa[i,contcomum+3]<-sum(tabelaa[,contcomum+2])
}


### tabela B = g2(y,v) = conjunta de Y e V
tabelab<-matrix(nr=numitensy+2, nc=contcomum+3)
tabelab[,]<-0
for (acertov in 0:contcomum)
{
	for(acertoy in 0:numitensy)
	{
		for(i in 1:NAY)
		{
			if (escorey[i,1]==acertoy & escorey[i,3]==acertov)
			{
			tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]+1
			}	
		}
	tabelab[acertoy+1,acertov+1]<-tabelab[acertoy+1,acertov+1]/NAY
	}
}

# marginal: calculo de h2(v)
contaux<-contcomum+2
for (i in 1:contaux)
{
tabelab[numitensy+2,i]<-sum(tabelab[,i])
}

# marginal: calculo de g2(y) e G2(y)
contaux<-numitensy+1
for (i in 1:contaux)
{
tabelab[i,contcomum+2]<-sum(tabelab[i,])
tabelab[i,contcomum+3]<-sum(tabelab[,contcomum+2])
}

### tabela C = f1(x|v) = condicional de x dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)=0 e h2(v)>0, procura um valor maior que zero em v+1, v+2...
tabelac<-matrix(nc=contcomum+1, nr=numitensx+1)
contaux1<-contcomum+1
contaux2<-numitensx+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[numitensx+2,j]==0 & tabelab[numitensy+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[numitensx+2,j]==0 & tabelab[numitensy+2,j]>0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelaa[numitensx+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelaa[numitensx+2,k]==0)
			{
				k<-j
				while (tabelaa[numitensx+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelac[i,j]<-tabelaa[i,k]/tabelaa[numitensx+2,k]		
		}
		if (tabelaa[numitensx+2,j]>0)
		{		
			tabelac[i,j]<-tabelaa[i,j]/tabelaa[numitensx+2,j]
		}
	}
}

### tabela D = g2(y|v) = condicional de y dado escores comuns v
# caso h1(v)=0 e h2(v)=0, atribui zero
# caso h1(v)>0 e h2(v)=0, procura um valor maior que zero em v+1, v+2...
tabelad<-matrix(nc=contcomum+1, nr=numitensy+1)
contaux1<-contcomum+1
contaux2<-numitensy+1
for (i in 1:contaux2)
{
	for(j in 1:contaux1)
	{
		if (tabelaa[numitensx+2,j]==0 & tabelab[numitensy+2,j]==0)
		{
			tabelac[i,j]<-0
		}
		if (tabelaa[numitensx+2,j]>0 & tabelab[numitensy+2,j]==0)
		{
			limite<-contaux1-j
			k<-j
			while (tabelab[numitensy+2,k]==0 & k<=limite)
			{
				k<-k+1
			}
			if (tabelab[numitensy+2,k]==0)
			{
				k<-j
				while (tabelab[numitensy+2,k]==0)
				{
					k<-k-1
				}
			}
			tabelad[i,j]<-tabelab[i,k]/tabelab[numitensy+2,k]		
		}
		if (tabelab[numitensy+2,j]>0)
		{		
			tabelad[i,j]<-tabelab[i,j]/tabelab[numitensy+2,j]
		}
	}
}

### tabela E = f1(x|v)*h2(v)
tabelae<-matrix(nc=contcomum+3, nr=numitensx+1)
tabelae[,]<-0
contaux1<-contcomum+1
contaux2<-numitensx+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelae[i,j]<-tabelac[i,j]*tabelaa[numitensx+2,j]
	}
	tabelae[i,contcomum+2]<-sum(tabelae[i,])
	tabelae[i,contcomum+3]<-sum(tabelae[,contcomum+2])
}


### tabela F = g2(y|v)*h1(v)
tabelaf<-matrix(nc=contcomum+3, nr=numitensy+1)
tabelaf[,]<-0
contaux1<-contcomum+1
contaux2<-numitensy+1
for (i in 1:contaux2)
{
	for (j in 1:contaux1)
	{
		tabelaf[i,j]<-tabelad[i,j]*tabelab[numitensy+2,j]
	}
	tabelaf[i,contcomum+2]<-sum(tabelaf[i,])
	tabelaf[i,contcomum+3]<-sum(tabelaf[,contcomum+2])
}


### tabela G = distr. acumuladas & rank percentil do teste X
### teste ncora INTERNO
tabelag<-matrix(nc=9, nr=numitensx+1)
nr<-numitensx+1
for (i in 1:nr)
{
	tabelag[i,1]<-i-1
}
tabelag[,2]<-tabelae[,contcomum+2]
tabelag[,3]<-tabelae[,contcomum+3]
tabelag[1,4]<-tabelag[1,2]/2
for (i in 2:nr)
{
	tabelag[i,4]<-tabelag[i-1,3]+tabelag[i,2]/2
}

### tabela H = distr. acumuladas & rank percentil do teste Y
### teste ncora INTERNO
tabelah<-matrix(nc=4, nr=numitensy+1)
nr<-numitensy+1
for (i in 1:nr)
{
	tabelah[i,1]<-i-1
}
tabelah[,2]<-tabelaf[,contcomum+2]
tabelah[,3]<-tabelaf[,contcomum+3]
tabelah[1,4]<-tabelah[1,2]/2
for (i in 2:nr)
{
	tabelah[i,4]<-tabelah[i-1,3]+tabelah[i,2]/2
}

### clculo de y* (tabela G)
nr<-numitensx+1
for (i in 1:nr)
{
	k<-1  #contador para o nmero de linhas

	while (tabelag[i,4]>=tabelah[k,3] && k<nrow(tabelah))
	{
		k<-k+1
	}
	if(k==nrow(tabelah))
	{
	if(tabelag[i,4]<tabelah[k,3]){tabelag[i,5]<-k-1}
	if(tabelag[i,4]>=tabelah[k,3]){tabelag[i,5]<-k}
	}
	else
	{
	tabelag[i,5]<-k-1    # k-1 = escore correspondente a y*
	}
}



### clculo de y** (tabela G)
for (i in 1:nr)
{
	k<-numitensy+1  #contador para o nmero de linhas
	if (tabelag[i,4]<=tabelah[1,3])
	{tabelag[i,6]<-(-1)}
	else
	{
		while (tabelag[i,4]<=tabelah[k,3])
		{
			k<-k-1
		}
		tabelag[i,6]<-k-1    # k-1 = escore correspondente a y**
	}
}


### clculo de ey*(x) (tabela G)
for (i in 1:nr)
{
k<-tabelag[i,5]
if(tabelag[i,4]==1)
	{tabelag[i,7]<-numitensy+0.5}
else
{
	if (k==0)
	{
	tabelag[i,7]<-(tabelag[i,4])/(tabelah[k+1,3])+k-0.5
	}
	else
	{
	tabelag[i,7]<-(tabelag[i,4]-tabelah[k,3])/(tabelah[k+1,3]-tabelah[k,3])+k-0.5
	}
}
}

### clculo de ey**(x) (tabela G)
for (i in 1:nr)
{
k<-tabelag[i,6]
if(tabelag[i,4]==0)
	{tabelag[i,8]<-(-0.5)}
else
{
	if (k==-1)
	{
	tabelag[i,8]<-(tabelag[i,4])/(tabelah[k+2,3])+k+0.5
	}
	else
	{
	if(k==nrow(tabelah)-1)
	{
	tabelag[i,8]<-tabelag[i,7]
	}
	else
	{
	tabelag[i,8]<-(tabelag[i,4]-tabelah[k+1,3])/(tabelah[k+2,3]-tabelah[k+1,3])+k+0.5
	}
	}
}
}

### clculo da mdia de ey*(x) e ey**(x) (tabela G)
for (i in 1:nr)
{
	tabelag[i,9]<-(tabelag[i,7]+tabelag[i,8])/2
}

}
#################################
#
# TESTE ANCORA INTERNO - FIM
#
#################################




# monta a matriz saida

saidaeq<-matrix(nc=4, nr=10)
saidaeq[1,1]<-"Metodo Equipercentil"
saidaeq[2,1]<-"===================="
saidaeq[4,1]<-"Teste X"
saidaeq[5,1]<-"======="
saidaeq[6,1]<-"num.individuos"
saidaeq[6,2]<-NAX
saidaeq[7,1]<-"num.itens comuns"
saidaeq[7,2]<-contcomum
saidaeq[8,1]<-"num.itens nao comuns"
saidaeq[8,2]<-contx
saidaeq[10,1]<-"escore (x)"
saidaeq[10,2]<-"f(x)"
saidaeq[10,3]<-"F(x)"
saidaeq[10,4]<-"P(x) (%)"

if (testeancora=="E")
{nlin<-contx+1}
if (testeancora=="I")
{nlin<-numitensx+1}

saidaaux<-matrix(nc=4, nr=nlin)
saidaaux[,1]<-tabelag[,1]
saidaaux[,2]<-format(tabelag[,2], digits=3, nsmall=3)
saidaaux[,3]<-format(tabelag[,3], digits=3, nsmall=3)
saidaaux[,4]<-format(100*tabelag[,4], digits=3, nsmall=3)

saidaeq<-rbind(saidaeq,saidaaux)

saidaaux<-matrix(nc=4, nr=8)
saidaaux[2,1]<-"Teste Y"
saidaaux[3,1]<-"======="
saidaaux[4,1]<-"num.individuos"
saidaaux[4,2]<-NAY
saidaaux[5,1]<-"num.itens comuns"
saidaaux[5,2]<-contcomum
saidaaux[6,1]<-"num.itens nao comuns"
saidaaux[6,2]<-conty
saidaaux[8,1]<-"escore (y)"
saidaaux[8,2]<-"g(y)"
saidaaux[8,3]<-"G(y)"
saidaaux[8,4]<-"Q(y) (%)"

saidaeq<-rbind(saidaeq,saidaaux)

if (testeancora=="E")
{nlin<-conty+1}
if (testeancora=="I")
{nlin<-numitensy+1}

saidaaux<-matrix(nc=4, nr=nlin)
saidaaux[,1]<-tabelah[,1]
saidaaux[,2]<-format(tabelah[,2], digits=3, nsmall=3)
saidaaux[,3]<-format(tabelah[,3], digits=3, nsmall=3)
saidaaux[,4]<-format(100*tabelah[,4], digits=3, nsmall=3)

saidaeq<-rbind(saidaeq,saidaaux)

saidaaux<-matrix(nc=4, nr=6)
saidaaux[2,1]<-"Equalizacao"
saidaaux[3,1]<-"==========="
saidaaux[4,1]<-"Teste ancora:"
if (testeancora=="E")
{saidaaux[4,2]<-"Externo"
nlin<-contx+1}
if (testeancora=="I")
{saidaaux[4,2]<-"Interno"
nlin<-numitensx+1}
saidaaux[6,1]<-"escore (x)"
saidaaux[6,2]<-"ey(x)"

saidaeq<-rbind(saidaeq,saidaaux)

saidaaux<-matrix(nc=4, nr=nlin)
saidaaux[,1]<-tabelag[,1]
saidaaux[,2]<-format(tabelag[,9], digits=3, nsmall=3)

saidaeq<-rbind(saidaeq,saidaaux)

saidaaux<-matrix(nc=4, nr=9)
ng<-length(tabelag[,1])  # numero de linhas da tabela g
nh<-length(tabelah[,1])  # numero de linhas da tabela h
saidaaux[2,1]<-"Momentos"
saidaaux[3,1]<-"========"
saidaaux[4,1]<-"escore"
saidaaux[4,2]<-"y"
saidaaux[4,3]<-"x"
saidaaux[4,4]<-"ey(x)"
saidaaux[5,1]<-"media"
saidaaux[6,1]<-"desvio-padrao"
saidaaux[7,1]<-"assimetria"
saidaaux[8,1]<-"curtose"

tabelaj<-matrix(nc=8, nr=ng)
for (i in 1:ng)
{
tabelaj[i,1]<-tabelag[i,1]*tabelag[i,2]  #x.f(x)
tabelaj[i,2]<-tabelag[i,9]*tabelag[i,2]	 #ey(x).f(x)
}
media1<-mean(tabelaj[,1])
dp1<-sqrt(var(tabelaj[,1]))
media2<-mean(tabelaj[,2])
dp2<-sqrt(var(tabelaj[,2]))
for (k in 1:ng)
	{
	tabelaj[k,3]<-(tabelaj[k,1]-media1)/dp1
	tabelaj[k,4]<-(tabelaj[k,3])^3	
	tabelaj[k,5]<-(tabelaj[k,3])^4	
	tabelaj[k,6]<-(tabelaj[k,2]-media1)/dp1
	tabelaj[k,7]<-(tabelaj[k,6])^3	
	tabelaj[k,8]<-(tabelaj[k,6])^4	
	}
tabelak<-matrix(nc=4, nr=nh)
for (i in 1:nh)
{
tabelak[i,1]<-tabelah[i,1]*tabelah[i,2]  #y.f(y)
}
media3<-mean(tabelak[,1])
dp3<-sqrt(var(tabelak[,1]))
for (k in 1:nh)
	{
	tabelak[k,2]<-(tabelak[k,1]-media3)/dp3
	tabelak[k,3]<-(tabelak[k,2])^3	
	tabelak[k,4]<-(tabelak[k,3])^4	
	}

# mdia
mediax<-sum(tabelaj[,1])
mediay<-sum(tabelaj[,2])
mediaey<-sum(tabelak[,1])
saidaaux[5,3]<-format(sum(tabelaj[,1]), digits=3, nsmall=3)
saidaaux[5,2]<-format(sum(tabelaj[,2]), digits=3, nsmall=3)
saidaaux[5,4]<-format(sum(tabelak[,1]), digits=3, nsmall=3)

# desvio padro
somax<-0
somaey<-0
for (j in 1:ng)
{
somax<-somax+(tabelag[j,2])*((tabelag[j,1]-mediax)^2)
dpx<-sqrt(somax)
somaey<-somaey+(tabelag[j,2])*((tabelag[j,9]-mediaey)^2)
dpey<-sqrt(somaey)
}

somay<-0
for (j in 1:nh)
{
somay<-somay+(tabelah[j,2])*((tabelah[j,1]-mediay)^2)
dpy<-sqrt(somay)
}

saidaaux[6,3]<-format(dpx, digits=3, nsmall=3)
saidaaux[6,2]<-format(dpy, digits=3, nsmall=3)
saidaaux[6,4]<-format(dpey, digits=3, nsmall=3)

# assimetria (skewness)
somax<-0
somaey<-0
for(t in 1:ng)
{
somax<-somax+((tabelag[t,1]-mediax)^3)*tabelag[t,2]
somaey<-somaey+((tabelag[t,9]-mediaey)^3)*tabelag[t,2]
}
assx<-somax/dpx^3
assey<-somaey/dpey^3

somay<-0
for(t in 1:nh)
{
somay<-somay+((tabelah[t,1]-mediay)^3)*tabelah[t,2]
}
assy<-somay/dpy^3

saidaaux[7,3]<-format(assx, digits=3, nsmall=3)
saidaaux[7,2]<-format(assy, digits=3, nsmall=3)
saidaaux[7,4]<-format(assey, digits=3, nsmall=3)

# curtose (kurtosis)
somax<-0
somaey<-0
for(t in 1:ng)
{
somax<-somax+((tabelag[t,1]-mediax)^4)*tabelag[t,2]
somaey<-somaey+((tabelag[t,9]-mediaey)^4)*tabelag[t,2]
}
kurtx<-somax/dpx^4
kurtey<-somaey/dpey^4

somay<-0
for(t in 1:nh)
{
somay<-somay+((tabelah[t,1]-mediay)^4)*tabelah[t,2]
}
kurty<-somay/dpy^4

saidaaux[8,3]<-format(kurtx, digits=3, nsmall=3)
saidaaux[8,2]<-format(kurty, digits=3, nsmall=3)
saidaaux[8,4]<-format(kurtey, digits=3, nsmall=3)

saidaeq<-rbind(saidaeq,saidaaux)



# retira os NA da matriz saida

for (i in 1:length(saidaeq[,1]))

{

	for (j in 1:length(saidaeq[1,]))

	{

	if (is.na(saidaeq[i,j])==TRUE)

		{

		saidaeq[i,j]<-" "

		}

	}

}


tkdestroy(tela)


# gera arquivo final "saida-equiper.txt"

write.matrix(saidaeq, file = "saida-fase2-Equipercentil.txt", sep = " ")


# mensagem de alerta
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="Os resultados da anlise esto nos arquivos 
saida-fase2-Equipercentil.txt .",icon="info",type="ok")