# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.

setwd("C:/TRI/exemplo")



# atribui os pesos para as populaes sintticas

# w1 = peso para a populao X

# w2 = peso para a populao Y



w1<-1

w2<-1-w1

# respostas so literais (A,B,C...) ou so numricas (corrigidas: 1=acerto, 0=erro)?
# Escolha "L" para literais ou "N" para numericas
tiporesposta<-"L"



############################################################################################
###	MTODO DE TUCKER - Equalizao clssica
############################################################################################

# Equalizao linear para grupos no equivalentes com teste ncora.
### arquivos entradax.txt e entraday.txt ###

# Os arquivos correspondentes aos testes X e Y devem-se chamar 'entradax.txt'

# e 'entraday.txt' (tudo em minusculas).
# A equalizao transforma os escores do teste X na escala do teste Y.

# Ao final ser gerado um arquivo chamado 'saida-fase2-Tucker.txt' com os resultados da 
# anlise e um arquivo chamado 'saida-fase2-graf-Tucker.jpg'.

# Configurao dos arquivos 'entradax.txt' e 'entraday.txt':

# primeira linha = nome do gabarito,A,B,D,E,....

# segunda linha = nmero de alternativas da questo correspondente separado por ','

# terceira linha = S se o item deve ser considerado na anlise ou

#                  N se no deve ser considerado na anlise separado por ','

# USE SEMPRE LETRAS MAIUSCULAS para 'S' e 'N'

# quarta linha = nomes dos itens separados por vrgulas. 

# ITENS COMUNS DEVEM TER O MESMO NOME!

# demais linhas = respostas dos indivduos: primeira coluna  a identificcao do 

# respondente e as demais colunas so as respostas, separados por vrgulas.

# Nas respostas e no gabarito, as letras devem ser todas maisculas ou todas minsculas.

# Deve estar disponvel a biblioteca MASS e tcltk para que o programa rode.

# Restrio: o nmero mximo de alternativas por item  igual a 20.

# Anlise realizada considerando os itens dicotmicos (certo ou errado).

# Os resultados apresentados esto na forma de proporo.

############################################################################################

#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################


library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );



# provax, provay = respostas

# infoprovax, infoprovay = informaes sobre nmero de itens, gabarito e analise



provax<-read.table("entradax.txt", header=TRUE, fill=TRUE, skip=3,sep=",")

infoprovax<-read.table("entradax.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")

provay<-read.table("entraday.txt", header=TRUE, fill=TRUE, skip=3,sep=",")

infoprovay<-read.table("entraday.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")



NAX<-length(provax[,1])  # NAX = nmero de indivduos que realizaram o teste X

NAY<-length(provay[,1])  # NAY = nmero de indivduos que realizaram o teste Y



NIX<-length(infoprovax[1,])-1   # NIX = nmero de itens do teste X+V

NIY<-length(infoprovay[1,])-1   # NIY = nmero de itens do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", what=list(""),n=length(infoprovax[1,]))

gabax<-respostax[[1]]  # vetor que contm o gabarito do teste X+V

respostay<-scan(file="entraday.txt", sep=",", what=list(""),n=length(infoprovay[1,]))

gabay<-respostay[[1]]  # vetor que contm o gabarito do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", skip=1, what=list(0),n=length(NIX))

alterx<-respostax[[1]]  # vetor que contm o nmero de alternativas por questo do teste X+V

respostay<-scan(file="entraday.txt", sep=",", skip=1, what=list(0),n=length(NIY))

altery<-respostay[[1]]  # vetor que contm o nmero de alternativas por questo do teste Y+V



respostax<-scan(file="entradax.txt", sep=",", skip=2, what=list(""),n=length(NIX))

considerax<-respostax[[1]]  # considera (S) ou desconsidera (N) o item

respostay<-scan(file="entraday.txt", sep=",", skip=2, what=list(""),n=length(NIY))

consideray<-respostay[[1]]  # considera (S) ou desconsidera (N) o item



respostax<-scan(file="entradax.txt", sep=",", skip=3, what=list(""),n=length(NIX))

nomeitemx<-respostax[[1]]  # nomes dos itens

respostay<-scan(file="entraday.txt", sep=",", skip=3, what=list(""),n=length(NIY))

nomeitemy<-respostay[[1]]  # nomes dos itens



### escores por indivduo do teste total (comum+no comum) ###

escorex<-matrix(nc=3, nr=NAX)  # escorex = escore dos indivduos do teste X+V

escorex[,]<-0   #atribui escore inicial zero a todos respondentes 

NIXaux<-NIX+1    # contador auxiliar

for(contaluno in 1:NAX)

{

	for(contitens in 2:NIXaux)

	{

		if(considerax[contitens-1]=="S")

		{

			if(provax[contaluno,contitens]==gabax[contitens])

			{

				escorex[contaluno,1]<-escorex[contaluno,1]+1

			}

		}

	}

}



escorey<-matrix(nc=3, nr=NAY)  # escorey = escore dos indivduos do teste Y+V

escorey[,]<-0   #atribui escore inicial zero a todos respondentes 

NIYaux<-NIY+1    # contador auxiliar

for(contaluno in 1:NAY)

{

	for(contitens in 2:NIYaux)

	{

		if(consideray[contitens-1]=="S")

		{

			if(provay[contaluno,contitens]==gabay[contitens])

			{

				escorey[contaluno,1]<-escorey[contaluno,1]+1

			}

		}

	}

}


if (tiporesposta=="L")
{

### alternativas possiveis ###

# limita o programa a no mximo 20 alternativas

alternativas<-c("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T")

if (max(alterx) > 20){
print("*** ERRO no teste X: numero maximo de alternativas por item e' igual 20!")
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO - teste X
Nmero mximo de alternativas por item  igual a 20!",icon="warning",type="ok")}

if (max(altery) > 20){
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO - teste Y
Nmero mximo de alternativas por item  igual a 20!",icon="warning",type="ok")
print("*** ERRO no teste Y: numero maximo de alternativas por item e' igual 20!")}

}


### localiza os itens comuns em cada uma das provas e cria vetor com essas posies

# poscomumx = posio dos itens comuns na prova x

# poscomumy = posio dos itens comuns na prova y



contcomum<-0  # conta o nmero de itens comuns



for (i in 2:NIXaux)

{

	for(j in 2:NIYaux)

	{

		if(nomeitemx[i]==nomeitemy[j])

		{
			if(considerax[i-1]=="S" & consideray[j-1]=="S")
			# considera que se um mesmo item for 'S' em um teste e 'N' em outro, 
			# o item no  comum
			{

				if(contcomum==0)

				{

				poscomumx<-c(i)

				poscomumy<-c(j)

				}

				else

				{

				poscomumx<-c(poscomumx,i)

				poscomumy<-c(poscomumy,j)

				}
				contcomum<-contcomum+1
			}

		}

	}

}

if (contcomum==0)

{

print("*** ERRO ***")

print("Nao foram encontrados itens comuns.")

print("Nao e' possivel realizar a equalizacao!")

print("Verifique se aos itens comuns foram atribuidos mesmo nome.")
ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO!
No foram encontrados itens comuns.
No  possvel realizar a equalizao!
Verifique se aos itens comuns foram atribuidos mesmo nome.",icon="warning",type="ok")

}



### calcula escores por indivduos para as partes no comuns (s X e s Y) e 

### para as comuns (VX e VY) dos testes X e Y



# calculo dos escores da prova VX

for(contaluno in 1:NAX)

{

	for(i in 1:length(poscomumx))

	{

		if(considerax[poscomumx[i]-1]=="S")

		{

			if(provax[contaluno,poscomumx[i]]==gabax[poscomumx[i]])

			{

				escorex[contaluno,3]<-escorex[contaluno,3]+1

			}

		}

	}

}



# calculo dos escores da prova X (no comum)

for(contaluno in 1:NAX)

{

escorex[contaluno,2]<-escorex[contaluno,1]-escorex[contaluno,3]

}





# calculo dos escores da prova VY

for(contaluno in 1:NAY)

{

	for(i in 1:length(poscomumy))

	{

		if(consideray[poscomumy[i]-1]=="S")

		{

			if(provay[contaluno,poscomumy[i]]==gabay[poscomumy[i]])

			{

				escorey[contaluno,3]<-escorey[contaluno,3]+1

			}

		}

	}

}



# calculo dos escores da prova Y (no comum)

for(contaluno in 1:NAY)

{

escorey[contaluno,2]<-escorey[contaluno,1]-escorey[contaluno,3]

}



# contagem do nmero de itens considerados
numitensx<-0
for (i in 1:length(considerax))
{
	if(considerax[i]=="S")
	{
	numitensx<-numitensx+1
	}
}

numitensy<-0
for (i in 1:length(consideray))
{
	if(consideray[i]=="S")
	{
	numitensy<-numitensy+1
	}
}


contx<-numitensx-contcomum  #nmero de itens no comuns do teste X
conty<-numitensy-contcomum  #nmero de itens no comuns do teste Y



###

### Estatsticas:

### clculo das mdias, desvios-padro e covarincia

###

### obs: os pesos w1 e w2 da pop. sintetica foram definidos no incio do programa

###

mi1x<-mean(escorex[,2]) # mdia dos itens no comuns da prova X

mi2y<-mean(escorey[,2]) # mdia dos itens no comuns da prova Y

mi1v<-mean(escorex[,3]) # mdia dos itens comuns da prova X

mi2v<-mean(escorey[,3]) # mdia dos itens comuns da prova Y

var1x<-var(escorex[,2]) # varincias

var2y<-var(escorey[,2]) 

var1v<-var(escorex[,3]) 

var2v<-var(escorey[,3])

cov1xv<-cov(escorex[,3],escorex[,2], method=c("pearson")) # covarincias

cov2yv<-cov(escorey[,3],escorey[,2], method=c("pearson"))



###

### Incio da equalizao 

### Mtodo: Tucker

### (Tucker  vlido para testes ncora internos e externos)

###

### Equao: l(x)=Ax+B



gama1<-cov1xv/var1v

gama2<-cov2yv/var2v

misx<-mi1x-w2*gama1*(mi1v-mi2v)

misy<-mi2y+w1*gama2*(mi1v-mi2v)

varsx<-var1x-w2*(gama1^2)*(var1v-var2v)+w1*w2*(gama1^2)*(mi1v-mi2v)^2

varsy<-var2y+w1*(gama2^2)*(var1v-var2v)+w1*w2*(gama2^2)*(mi1v-mi2v)^2



Atucker<-sqrt(varsy/varsx)  # coef. angular na equalizao pelo mt. Tucker

Btucker<-misy-Atucker*misx  # coef. linear na equalizao pelo mt. Tucker



# controi matriz com escore equalizados

linhas<-numitensx+1
equa<-matrix(nc=3, nr=linhas)
for (i in 1:linhas)
{
equa[i,1]<-i-1
equa[i,2]<-Atucker*(i-1)+Btucker
if(equa[i,2]<0) {equa[i,2]<-0}
if(equa[i,2]>numitensy) {equa[i,2]<-numitensy}
}
equa[,2]<-format(equa[,2], digits=3, nsmall=3)


### monta a matriz saida

saidatuc<-matrix(nc=3, nr=45)
saidatuc[1,1]<-"Metodo de Tucker"
saidatuc[2,1]<-"================"
saidatuc[3,1]<-"Pop.1 = teste X"
saidatuc[4,1]<-"Pop.2 = teste Y"

saidatuc[5,1]<-"Pesos pop. sintet."
saidatuc[6,1]<-"------------------"
saidatuc[7,1]<-"w1:"
saidatuc[7,2]<-w1
saidatuc[8,1]<-"w2:"
saidatuc[8,2]<-w2

saidatuc[10,1]<-"Numero de itens"
saidatuc[11,1]<-"---------------"
saidatuc[12,1]<-"Teste X (nao comum):"
saidatuc[12,2]<-contx
saidatuc[13,1]<-"Teste Y (nao comum):"
saidatuc[13,2]<-conty
saidatuc[14,1]<-"Teste V (comum):"
saidatuc[14,2]<-contcomum

saidatuc[16,1]<-"Numero respondentes"
saidatuc[17,1]<-"-------------------"
saidatuc[18,1]<-"Teste X:"
saidatuc[18,2]<-NAX
saidatuc[19,1]<-"Teste Y:"
saidatuc[19,2]<-NAY

saidatuc[21,1]<-"Grupo + Teste"
saidatuc[22,1]<-"-------------"
saidatuc[21,2]<-"Media"
saidatuc[22,2]<-"-----"
saidatuc[21,3]<-"Desvio-padrao"
saidatuc[22,3]<-"-------------"
saidatuc[23,1]<-"G1 - teste X"
saidatuc[23,2]<-format(mi1x, digits=3, nsmall=3)
saidatuc[23,3]<-format(sqrt(var1x), digits=3, nsmall=3)
saidatuc[24,1]<-"G1 - teste V"
saidatuc[24,2]<-format(mi1v, digits=3, nsmall=3)
saidatuc[24,3]<-format(sqrt(var1v), digits=3, nsmall=3)

saidatuc[26,1]<-"G2 - teste Y"
saidatuc[26,2]<-format(mi2y, digits=3, nsmall=3)
saidatuc[26,3]<-format(sqrt(var2y), digits=3, nsmall=3)
saidatuc[27,1]<-"G2 - teste V"
saidatuc[27,2]<-format(mi2v, digits=3, nsmall=3)
saidatuc[27,3]<-format(sqrt(var2v), digits=3, nsmall=3)

saidatuc[29,1]<-"Estatisticas"
saidatuc[30,1]<-"------------"
saidatuc[31,1]<-"gama1:"
saidatuc[31,2]<-format(gama1, digits=3, nsmall=3)
saidatuc[32,1]<-"gama2:"
saidatuc[32,2]<-format(gama2, digits=3, nsmall=3)
saidatuc[33,1]<-"media pop. sint. X: "
saidatuc[33,2]<-format(misx, digits=3, nsmall=3)
saidatuc[34,1]<-"media pop. sint. Y: "
saidatuc[34,2]<-format(misy, digits=3, nsmall=3)
saidatuc[35,1]<-"desvio-padrao X:"
saidatuc[35,2]<-format(sqrt(varsx), digits=3, nsmall=3)
saidatuc[36,1]<-"desvio-padrao Y:"
saidatuc[36,2]<-format(sqrt(varsy), digits=3, nsmall=3)

saidatuc[38,1]<-"Modelo de equaliz.: "
saidatuc[39,1]<-"------------------- "
saidatuc[38,2]<-"ly(x) = Ax + B"
saidatuc[40,1]<-"A (inclinacao):"
saidatuc[40,2]<-format(Atucker, digits=3, nsmall=3)
saidatuc[41,1]<-"B (intercepto):"
saidatuc[41,2]<-format(Btucker, digits=3, nsmall=3)

saidatuc[43,1]<-"Escores equalizados"
saidatuc[43,2]<-"- Teste Interno"
saidatuc[44,1]<-"-------------------"
saidatuc[45,1]<-"escore x"
saidatuc[45,2]<-"lY(x)"

saidatuc<-rbind(saidatuc,equa)



# retira os NA da matriz saida

for (i in 1:length(saidatuc[,1]))

{

	for (j in 1:length(saidatuc[1,]))

	{

	if (is.na(saidatuc[i,j])==TRUE)

		{

		saidatuc[i,j]<-" "

		}

	}

}


tkdestroy(tela)


# gera arquivo final "saida-fase2-Tucker.txt"

write.matrix(saidatuc, file = "saida-fase2-Tucker.txt", sep = " ")

# gera as regresses de X em V e de Y em V
x1<-escorex[,1]
v1<-escorex[,3]
y2<-escorey[,1]
v2<-escorey[,3]
regx<-lm(x1~v1)
regy<-lm(y2~v2)

# cria arquivo com os grficos de regresso e resduos

jpeg(filename = "saida-fase2-graf-Tucker.jpg", width = 500, height = 500,pointsize = 12, quality = 75, bg = "white")

par(mfcol=c(2,2))
plot(v1,x1,xlab="escores teste V", ylab="escores teste X", main="Regresso de X em V")
abline(regx)
plot(residuals(regx),  xlab="Individuos", ylab="Residuos", main="Residuos de X em V")
plot(v2,y2,xlab="escores teste V", ylab="escores teste Y", main="Regresso de Y em V")
abline(regy)
plot(residuals(regy), xlab="Individuos", ylab="Residuos", main="Residuos de Y em V")

dev.off()

ReturnVal <- tkmessageBox(title="Equalizao clssica - Levine",message="Os resultados da anlise esto nos arquivos 
saida-fase2-Tucker.txt e 
saida-fase2-graf-Tucker.jpg .",icon="info",type="ok")

