# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.
setwd("C:/TRI/exemplo")

# nmero mximo de iteraes do algoritmo Newton Raphson
tmax<-50

# critrio de parada para o algoritmo Newton Raphson (valor em mdulo)
crit<-0.01

############################################################################################
# Calibrao - parmetros do item conhecidos e habilidades desconhecidas - teste Y
############################################################################################
### arquivo entraday.txt ###
# O arquivo que deseja realizar a anlise deve-se chamar 'entraday.txt' (tudo em minusculas)
# ao final ser gerado um arquivo chamado 'saida-fase3-habil-y.txt' e um arquivo
# 'habilidadesy.txt' que contm apenas as habilidades estimadas e pode ser utilizado
# no programa de equalizao entre dois testes.
# Configurao do arquivo 'entraday.txt':
# primeira linha = nome do gabarito,A,B,D,E,....
# segunda linha = nmero de alternativas da questo correspondente separado por ','
# terceira linha = S se o item deve ser considerado na anlise ou
#                  N se no deve ser considerado na anlise separado por ','
# USE SEMPRE LETRAS MAIUSCULAS para 'S' e 'N'
# quarta linha = nomes dos itens separados por vrgulas 
# demais linhas = respostas dos indivduos: primeira coluna  a identific. do 
# respondente e as demais colunas so as respostas, separados por vrgulas.
# Nas respostas e no gabarito, as letras devem ser todas maiusculas ou todas minusculas.
# Devem estar disponveis a biblioteca MASS e tcltk para que o programa rode.
# Restrio: o nmero mximo de alternativas por item  igual a 20.
# Anlise realizada considerando os itens dicotmicos (certo ou errado).
# Considera-se que as respostas colocadas em entraday.txt porvm de um nico grupo.
# Os resultados apresentados esto na mesma escala dos parmetros dos itens.
### arquivo parametrosy.txt ###
# Deve constar os valores dos parmetros (a,b,c) apenas dos itens "considerados" no
# o modelo logstico de 3 parmetros. Esses parmetros devem estar separados por vrgula.
### AVISO
# O uso de poucos itens ou poucos individuos pode acarretar em problemas na estimao!
############################################################################################
#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***
############################################################################################

library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );

# provax = respostas
# infoprovax = informaes sobre nmero de itens, gabarito e analise

provax<-read.table("entraday.txt", header=TRUE, fill=TRUE, skip=3,sep=",",as.is=TRUE)
infoprovax<-read.table("entraday.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")

NAX<-length(provax[,1])  # NAX = nmero de indivduos que realizaram o teste Y

NIX<-length(infoprovax[1,])-1   # NIX = nmero de itens do teste Y+V

respostax<-scan(file="entraday.txt", sep=",", what=list(""),n=length(infoprovax[1,]))
gabax<-respostax[[1]]  # vetor que contm o gabarito do teste Y+V

respostax<-scan(file="entraday.txt", sep=",", skip=1, what=list(0),n=length(NIX))
alterx<-respostax[[1]]  # vetor que contm o nmero de alternativas por questo do teste Y+V

respostax<-scan(file="entraday.txt", sep=",", skip=2, what=list(""),n=length(NIX))
considerax<-respostax[[1]]  # considera (S) ou desconsidera(N) o item

respostax<-scan(file="entraday.txt", sep=",", skip=3, what=list(""),n=length(NIX))
nomeitemx<-respostax[[1]]  # nomes dos itens

### leitura dos parmetros
abc<-read.table("parametrosy.txt", header=FALSE, fill=TRUE, sep=",")

### contagem do nmero de itens considerados
numitensx<-0
for (i in 1:length(considerax))
{
	if(considerax[i]=="S")
	{
	numitensx<-numitensx+1
	}
}


### emite alerta
if (length(abc[,1])!=numitensx)
	{
	print("*** ERRO ***")
	print("Numero de parametros do arquivo parametros.txt eh diferente")
	print("do numero de itens do arquivo entraday.txt!")
	ReturnVal <- tkmessageBox(title="Estimao - TRI",message="ERRO!
        Nmero de parmetros do arquivo parametrosy.txt  diferente
	do nmero de itens do arquivo entraday.txt!",icon="warning",type="ok")
	}

### escores por indivduo ###
escorex<-matrix(nc=1, nr=NAX)  # escorex = escore dos indivduos do teste Y+V
escorex[,1]<-0   #atribui escore inicial zero a todos respondentes 
NIXaux<-NIX+1    # contador auxiliar
for(contaluno in 1:NAX)
{
	for(contitens in 2:NIXaux)
	{
		if(considerax[contitens-1]=="S")
		{
			if(provax[contaluno,contitens]==gabax[contitens])
			{
				escorex[contaluno,1]<-escorex[contaluno,1]+1
			}
		}
	}
}

### escore mdio e desvio-padro
escoremedio<-mean(escorex[,1])
escoredp<-sqrt(var(escorex[,1]))


###
### Verifica se h escores nulos ou perfeitos. Caso haja, atribui 0.5
### no item mais fcil para o aluno com escore nulo e atribui 0.5 no
### item mais difcil para o aluno com escore perfeito.
###

# numero de itens considerados
contconsidera<-0
for (i in 1:NIX)
{
	if (considerax[i]=="S")
	{
	contconsidera<-contconsidera+1  
	}
}

# verifica se h escore nulo
if (min(escorex)==0)
{

	menorb<-10000
	for (k in 1:length(abc[,1]))
	{
		if (abc[k,2]<menorb) {menorb<-abc[k,2]}  #determina o menor b
	}
	
	cont<-1
	for (i in 1:NIX)
	{
		if(considerax[i]=="S")
		{
			if (menorb == abc[cont,2])
			{contmenorb<-i} # contmenorb = nmero do item mais fcil
			cont<-cont+1
		}

	}

}

# verifica se h escore perfeito
if (max(escorex)==contconsidera)
{
	maiorb<--10000 
	for (k in 1:length(abc[,1]))
	{
		if (abc[k,2]>maiorb) {maiorb<-abc[k,2]}  #determina o maior b
	}

	cont<-1
	for (i in 1:NIX)
	{
		if(considerax[i]=="S")
		{
			if (maiorb == abc[cont,2])
			{contmaiorb<-i} # contmaiorb = nmero do item mais difcil
			cont<-cont+1
		}
	}

}



###
### incio do processo de Newton Raphson para modelo logstico com 3 parametros
###

tetas<-matrix(nr=NAX, nc=3)  # matriz com os tetas estimados e os erros-padres

for (j in 1:NAX)
{

# estimativa inicial para teta de individuo j
teta<-(escorex[j,1]-escoremedio)/escoredp

# t = nmero de iteraes em Newton Raphson
t<-0

para<-"NAO"  # NAO = no interrompe o algoritmo


### incio do Newton Raphson

while (para=="NAO")
{

hess<-0
S<-0
soma<-0
contpar<-1 # contador para o arquivo de parametros (s contem os parametros dos 
	   # itens considerados na analise

for (i in 1:NIX)
	{
	if (considerax[i]=="S")
	{
	# parametros a,b,c
	a<-abc[contpar,1]
	b<-abc[contpar,2]
	c<-abc[contpar,3]

	# calculo de P e Q usando a funo de resposta ao item
	P<-c+(1-c)/(1+exp(-a*(teta-b)))
	Q<-1-P
	
	# calculo de Pestr e Qestr usando a funo de resposta ao item	
	Pestr<-1/(1+exp(-a*(teta-b)))
	Qestr<-(1-Pestr)

	# calculo de W
	W<-(Pestr*Qestr)/(P*Q)

	# calculo de h e H
	h<-a*(1-c)
	H<-(a^2)*(1-c)*(1-2*Pestr)
	
	# calculo de y
	if (provax[j,i+1]==gabax[i+1])
	{
		y<-1
		if(escorex[j]==contconsidera)
			{
			if(i==contmaiorb) {y<-0.5}
			}
		
		if(escorex[j]==0)
			{
			if(i==contmenorb) {y<-0.5}
			}
		
	}
	else {y<-0}

	# vetor escore
	S<-S+a*(1-c)*(y-P)*W

	# matriz hessiana
	hess<-hess+(y-P)*W*(H-(y-P)*W*(h^2))

	### clculo do erro-padro 
	soma<-soma+Pestr*Qestr*W*h^2
	
	contpar<-contpar+1
	}
	}

# algoritmo de Newton Raphson
teta2<-teta-(1/hess)*S
t<-t+1

delta<-teta2-teta  # calcula a diferena das estimativas dos passos t+1 e t

teta<-teta2


### verifica se continua ou interrompe o algoritmo
if (t>tmax) {para<-"SIM"} else 
	{
	if (Mod(delta)<=crit) {para<-"SIM"}
	else {para<-"NAO"}
	}

}

tetas[j,1]<-teta  # teta estimado
tetas[j,2]<-sqrt(soma)  # erro padro
tetas[j,3]<-t  # numero de ciclos NR

}

tetas2<-tetas
tetas2[,1]<-round(tetas2[,1], digits=3)
tetas2[,2]<-round(tetas2[,2], digits=3)

#
# cria matriz com saida dos dados
#

saida<-matrix(nc=4, nr=6)
saida[1,1]<-"Estimacao de"
saida[1,2]<-"habilidades"
saida[1,3]<-"- Teste Y"
saida[2,1]<-"parametros"
saida[2,2]<-"(conhecidos)"
saida[3,1]<-"Num. respond.:"
saida[3,2]<-NAX

saida[5,1]<-"identificacao"
saida[5,2]<-"Habilidade"
saida[5,3]<-"Erro-padrao"
saida[5,4]<-"Num. ciclos"

saida2<-matrix(nc=3, nr=length(provax[,1]))

saida2[,]<-tetas2[,]


# retira os NA da matriz saida
for (i in 1:length(saida[,1]))
{
	for (j in 1:length(saida[1,]))
	{
	if (is.na(saida[i,j])==TRUE)
		{
		saida[i,j]<-" "
		}
	}
}

saida2<-cbind(provax[1],saida2)
saida2[,1] <- as.character(saida2[,1])
saida2[,2] <- as.character(saida2[,2])
saida2[,3] <- as.character(saida2[,3])
saida2[,4] <- as.character(saida2[,4])

colnames(saida) <- names(saida2)
csaida <- saida

saida3<-rbind( as.data.frame(saida), saida2)


habilid<-tetas[,1]

tkdestroy(tela)

# gera arquivo final "saida-fase3-habil-y.txt"
write.matrix(saida3, file = "saida-fase3-habil-y.txt", sep = " ")

write.matrix(habilid, file = "habilidadesy.txt", sep = " ")

# mensagem de alerta
ReturnVal <- tkmessageBox(title="Estimao - TRI",message="Os resultados da anlise esto nos arquivos 
saida-fase3-habil-y.txt .",icon="info",type="ok")


