# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.
setwd("C:/TRI/exemplo")

# respostas so literais (A,B,C...) ou esto numricas (corrigidas: 1=acerto, 0=erro)?
# Escolha "L" para literais ou "N" para numericas
tiporesposta<-"L"

### Define os chutes iniciais ('chuteinicial') de acordo com os nmeros a seguir (de 1 a 4):
# (Em todas as possibilidades, c  obtido a partir do nmero de alternativas do item).
#
# 1 - chute padro recomendado na literatura: 
#	a = obtido a partir da correlao ponto bisserial
#	b = obtido a partir da curva normal + ponto bisserial
#
# 2 - a = todos os valores de a recebem uma constante (defina o valor de 'chute.a') (sugesto: 1)
#     b = obtido a partir da curva normal + ponto bisserial
#
# 3 - a = todos os valores de a recebem uma constante (defina o valor de 'chute.a') (sugesto: 1)
#     b = todos os valores de b recebem uma constante (defina o valor de 'chute.b') (sugesto: 0)
#
# 4 - a = valores gerados de uma log-normal com mdia 'lognor.media' e desvio-padro
#         'lognor.dp' (sugesto: mdia 0 e varincia 0.3)
#     b = obtido a partir da curva normal (0,1)
#
# 5 - a = valores gerados de uma log-normal com mdia 'lognor.media' e desvio-padro
#         'lognor.dp' (sugesto: mdia 0 e varincia 0.3)
#     b = gerados a partir da curva normal N(0,1)
#     c = obtido a partir de uma beta (defina parametros c1 e c2) (sugesto: c1=6 e c2=16)

chuteinicial<-2

chute.a<-1
chute.b<-0

lognor.media<-0
lognor.dp<-0.3

c1<-6
c2<-16

###
### Configuraes avanadas
###

### Gerao dos pontos de quadratura:

# nmero de pontos de quadratura
npq<-10

# amplitude do intervalo para pontos de quadratura
limite<-4

# mdia da curva normal para pontos de quadratura
m.norm<-0

# varincia da curva normal para pontos de quadratura
var.norm<-1

### atualizao condicional do algoritmo EM:

# limite inferior para parmetro a
lia<-0

# limite superior para parmetros a
lsa<-2.2

# limite para parmetro d
ld<-6


### critrios de parada:

# 1 - nmero de ciclos do algoritmo EM
n.ciclo.EM<-50

# 2 - preciso das estimatimas dos itens
prec.item.EM<-0.001



############################################################################################
# Calibrao - parmetros do item e habilidades desconhecidos - Teste X
############################################################################################
### arquivo entradax.txt ###
# O arquivo que deseja realizar a anlise deve-se chamar 'entradax.txt' (tudo em minusculas)
# ao final ser gerado um arquivo chamado 'saida-fase3-TRI-x.txt' e um arquivo temporrio
# que ser usado apenas no caso de se querer estimar as habilidades dos respondentes chamado
# 'parametrosx.txt' que contm os valores dos parmetros dos itens calibrados.
# Configurao do arquivo 'entradax.txt':
# primeira linha = nome do gabarito,A,B,D,E,....
# obs: o gabarito pode ser numrico, ou seja, 0 indicando erro e 1 acerto do item.

# segunda linha = nmero de alternativas da questo correspondente separado por ','
# terceira linha = S se o item deve ser considerado na anlise ou
#                  N se no deve ser considerado na anlise separado por ','
# USE SEMPRE LETRAS MAIUSCULAS para 'S' e 'N'
# quarta linha = nomes dos itens separados por vrgulas 
# demais linhas = respostas dos indivduos: primeira coluna  a identific. do 
# respondente e as demais colunas so as respostas, separados por vrgulas.
# Nas respostas e no gabarito, as letras devem ser todas maiusculas ou todas minusculas.
# Deve estar disponvel a biblioteca MASS para que o programa rode.
# Restrio: o nmero mximo de alternativas por item  igual a 20.
# Anlise realizada considerando os itens dicotmicos (certo ou errado).
# Considera-se que as respostas colocadas em entradax.txt porvm de um nico grupo.
# Os resultados apresentados esto na forma de proporo.
############################################################################################
#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################


library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );


# provax = respostas
# infoprovax = informaes sobre nmero de itens, gabarito e analise

provax<-read.table("entradax.txt", header=TRUE, fill=TRUE, skip=3,sep=",")
infoprovax<-read.table("entradax.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")

NAX<-length(provax[,1])  # NAX = nmero de indivduos que realizaram o teste X

NIX<-length(infoprovax[1,])-1   # NIX = nmero de itens do teste X+V

respostax<-scan(file="entradax.txt", sep=",", what=list(""),n=length(infoprovax[1,]))
gabax<-respostax[[1]]  # vetor que contm o gabarito do teste X+V

respostax<-scan(file="entradax.txt", sep=",", skip=1, what=list(0),n=length(NIX))
alterx<-respostax[[1]]  # vetor que contm o nmero de alternativas por questo do teste X+V

respostax<-scan(file="entradax.txt", sep=",", skip=2, what=list(""),n=length(NIX))
considerax<-respostax[[1]]  # considera (S) ou desconsidera(N) o item

respostax<-scan(file="entradax.txt", sep=",", skip=3, what=list(""),n=length(NIX))
nomeitemx<-respostax[[1]]  # nomes dos itens

NIXaux<-NIX+1

# conta nmero de itens considerados na analise
I<-0
for (i in 1:NIX)
{
	if(considerax[i]=="S")
	{I<-I+1}
}

Iaux<-I+1



if (tiporesposta=="N")
{
	zeroumx<-matrix(nr=NAX, nc=1)
	col<-0
	binario<-matrix(nr=I, nc=1)  # matriz de 0 e 1 

	for (contitens in 2:NIXaux)
	{
		contitens2<-contitens-1
		if (considerax[contitens2]=="S") 
		{
		zeroumx[,1]<-provax[,contitens]
		if (col==0) 
			{binario<-zeroumx
			col<-1
			nalter<-c(alterx[contitens2])
			} 
			else 
			{binario<-cbind(binario,zeroumx)
			nalter<-c(nalter,alterx[contitens2])}

		}
	}
}


if (tiporesposta=="L")
{

	### alternativas possiveis ###
	# limita o programa a no mximo 20 alternativas
	alternativas<-c("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T")
	if (max(alterx) > 20){
	ReturnVal <- tkmessageBox(title="Equalizao clssica - Equipercentil",message="ERRO!
        Nmero mximo de alternativas por item  igual 20!",icon="warning",type="ok")

	print("*** ERRO: nmero mximo de alternativas por item  igual 20!")}

	### cria vetor de posio das alternativas corretas
	# posgaba = posio da alternativa correta
	for (i in 2:NIXaux)
	{
		for (j in 1:20)
		{
			if (gabax[i]==alternativas[j])
			{
				if (i==2) {posgaba<-c(j)}
				else {posgaba<-c(posgaba,j)}
			}
		}
	}


	### gera matriz de 0 (erro) e 1 (acerto) para cada item
	# contitens = posio do item na matrix provax
	# conteitens2 = posio do item nas matrizes alterx e considerax

	col<-0
	binario<-matrix(nr=I, nc=1)  # matriz de 0 e 1 completa (todo teste)
	for (contitens in 2:NIXaux)
	{
	contitens2<-contitens-1
	if (considerax[contitens2]=="S") 
		{
		zeroumx<-matrix(nr=NAX, nc=1)
			for(contaluno in 1:NAX)
				{
				if (alternativas[posgaba[contitens2]]==provax[contaluno,contitens])
					{zeroumx[contaluno,1]<-1}
					else
					{zeroumx[contaluno,1]<-0}
				}
		if (col==0) 
			{binario<-zeroumx
			col<-1
			nalter<-c(alterx[contitens2])} 
			else 
			{binario<-cbind(binario,zeroumx)
			nalter<-c(nalter,alterx[contitens2])}

		}
	}

}





#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 1 - inicio
#
#@@@@@@@@@@@@@@@@@@@@@@@

nalter<-cbind(nalter)
modelo<-3
n <- NAX 


gera.est.ini.MRD <- function(binario,nalter,modelo)
{

v.escore <- apply(binario,1,sum) # vetor com os escores dos indivduos

me.escore <- mean(v.escore) # escore mdio dos indivduos

var.escore <- var(v.escore) # varincia dos escores dos indivduos

v.escore.pa <- cbind((v.escore - me.escore)/sqrt(var.escore)) # escores padronizados

# dificuldade clssica, proporo de acertos

v.pr.ac <- cbind(apply(binario,2,mean)) 

# matriz de correlao bisserial

m.aux.corre.bis <- matrix(0,n,I + 1) # matriz auxiliar para o clculo da matriz de correlao biserial

m.aux.corre.bis[,1:I] <- binario

m.aux.corre.bis[,I+1] <- apply(binario,1,sum)

# matriz de correlaes bisseriais

m.corre.bis <- cor(m.aux.corre.bis)

# vetor com as correlaes bisseriais de interesse

v.corre.bis <- cbind(m.corre.bis[1:I,I + 1])

### modelo de 3 parmetros

# valores iniciais para os processos
# iterativos

# parmetros de discriminao

ve.a0 <- cbind(sqrt((v.corre.bis^2)/(1 - (v.corre.bis^2))))


# parmetros de dificuldade


# valores iniciais para os processos
# iterativos


# parmetros de discriminao
ve.a0 <- (sqrt((v.corre.bis^2)/(1 - (v.corre.bis^2))))

# parmetros de dificuldade
ve.b0 <- -(qnorm(v.pr.ac)/v.corre.bis)

# parmetros de inclinao
ve.d0 <- -ve.a0 * ve.b0

# vetor com as estimativas dos parmetros
me.par.ite <- cbind(c(ve.a0),c(ve.b0),c(ve.d0))

# parmetros de inclinao
ve.d0 <- -ve.a0 * ve.b0

# parmetros de acerto ao acaso
ve.c0 <- (cbind(1/nalter))

# vetor com as estimativas dos parmetros
me.par.ite <- cbind(ve.a0,ve.b0,ve.d0,ve.c0)


result.gera.est.ini.MRD <- list(me.par.ite=me.par.ite)

return(result.gera.est.ini.MRD)

}


#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 1 - fim
#
#@@@@@@@@@@@@@@@@@@@@@@@


gera.est<-gera.est.ini.MRD(binario,nalter,modelo)$me.par.ite  # matriz com os chutes iniciais (a,b,d,c)

v.a<-c(gera.est[,1])
v.b<-c(gera.est[,2])
v.d<-c(gera.est[,3])
v.c<-c(gera.est[,4])



#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 2 - inicio
#
#@@@@@@@@@@@@@@@@@@@@@@@

D<-1
prob.tri.repar <- function(v.a,v.d,v.c,v.theta,D)

# v.a : vetor com as inclinaes
# v.d : vetor com os interceptos
# v.c : vetor com os parmetros de acerto ao acaso
# v.theta : vetor com os traos latentes
# D : escalar com o parmetro de modificao da funo de ligao.

{
v.a <- cbind(v.a)
v.d <- cbind(v.d)
v.c <- cbind(v.c)
v.theta <- cbind(v.theta)     

# matriz com os valores do parmetro de discriminao

m.a <- kronecker(matrix(1,nrow(v.theta),1),t(v.a))

# matriz com os valores do parmetro de discriminao

m.d <- kronecker(matrix(1,nrow(v.theta),1),t(v.d))

# matriz com os valores do parmetro de discriminao

m.c <- kronecker(matrix(1,nrow(v.theta),1),t(v.c))
    
# matriz com os valores dos traos latentes

m.theta <- matrix(v.theta,nrow(v.theta),nrow(v.d))

# matriz com as probabilidades de resposta correta

m.P <-  m.c + (1 - m.c)/(1 + exp(-D*(m.a*m.theta + m.d)))

# matriz com as probabilidades de resposta incorreta

m.Q <- 1 - m.P

result.prob.tri.dic <- list(m.P=m.P,m.Q=m.Q,m.a=m.a,m.d=m.d,m.c=m.c)

return(result.prob.tri.dic)

}


#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 2 - fim
#
#@@@@@@@@@@@@@@@@@@@@@@@


#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 3 - inicio - pts de quadratura
#
#@@@@@@@@@@@@@@@@@@@@@@@


  gera.quad.norm.mrd<-function(npq,limite,m.norm,var.norm)

# npq = numero de pts de quadratura
# limite = amplitude do intervalo
# m.norm = media
# var.norm = variancia

{  

l.inf <- m.norm - limite*sqrt(var.norm) # limite inferior para a gerao dos pontos de
                                        # quadratura

l.sup <- m.norm + limite*sqrt(var.norm) # limite inferior para a gerao dos pontos de
                                        # quadratura

inc <- (l.sup - l.inf)/(npq - 1) # incremento para os pontos de quadratura

v.pq <- cbind(seq(l.inf,l.sup,inc)) # pontos de quadratura

c.inter <- inc*matrix(1,npq,1) # vetor com as larguras do retngulo

dens.norm <- cbind(dnorm(v.pq,m.norm,var.norm)) # vetor com as densidades nos pontos 
                                           # de quadratura

w.pq <- dens.norm*c.inter # pesos associados aos pontos de quadratura

result.gera.quad.norm.mrd <- list(dens.norm=dens.norm,w.pq=w.pq,v.pq=v.pq)

return(result.gera.quad.norm.mrd)

}

#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 3 - fim
#
#@@@@@@@@@@@@@@@@@@@@@@@

gera.quad<-gera.quad.norm.mrd(npq,limite,m.norm,var.norm)  #funo 3

v.theta<-gera.quad$v.pq  # valores dos pontos de quadratura

prob.tri<-prob.tri.repar(v.a,v.d,v.c,v.theta,D) # funo 2

m.P<-prob.tri$m.P # matriz com as probabilidades de escolha

v.Al<-gera.quad$w.pq  # pesos de quadratura


#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 4 - inicio
#
#@@@@@@@@@@@@@@@@@@@@@@@

# Gera a verossimilhana 

gera.veross.MRD <- function(binario,m.P,v.Al)

{

# binario : matriz com as respostas dos indivduos
# m.P : matriz com as probabilidades de escolha
# v.Al : matriz com os pesos de quadratura 
# esc.veros : define a verossimilhana por indivduo
#             utilizada
#             1 - verossimilhana genuna
#             2 - verossimilhana ponderada pelos
#                 pontos de quadratura


v.Al <- cbind(v.Al)


# matriz com as logverossimilhanas por indivduo
# m.P precisa ter o nmero q de linhas
# se os parmetros dos itens forem desconhecidos


# matriz com os pontos de quadratura

m.Al <- t(matrix(v.Al,nrow(v.Al),nrow(binario)))

# matriz com as logverossimilhanas por indivduo
# m.P precisa ter o nmero ter q linhas
# se os parmetros dos itens forem desconhecidos

m.lntheta.mrd <- binario%*%log(t(m.P)) + (1 - binario)%*%log(1 - t(m.P)) + log((m.Al)) # (n x q)

# matriz com as logverossimilhanas por indivduo

m.Ltheta.mrd <- exp(m.lntheta.mrd)


result.gera.veross.mrd<-list(m.lntheta.mrd=m.lntheta.mrd,m.Ltheta.mrd=m.Ltheta.mrd)

return(result.gera.veross.mrd)

}

#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 4 - fim
#
#@@@@@@@@@@@@@@@@@@@@@@@

gera.veross.MRD<-gera.veross.MRD(binario,m.P,v.Al)

m.Ltheta.mrd.Al<-gera.veross.MRD$m.Ltheta.mrd



#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 5 - inicio
#
#@@@@@@@@@@@@@@@@@@@@@@@


## Gera os dados artificiais utilizados na estimao pelo
## algoritmo EM

gera.dados.art.MRD <- function(m.Y,m.Ltheta.mrd.Al)

{

# m.Y : matriz com as respostas dos indivduos
# m.Ltheta.mrd : matriz com as logverossimilhanas
#                por indivduo (ponderada pelos pontos
#                de quadratura)


# vetor com as somas das logverossimilhanas
v.sLtheta.Al <- cbind(apply(m.Ltheta.mrd.Al,1,sum))

# matriz auxiliar com as somas
# das verossimilhanas ponderadas
m.sLtheta.Al <- matrix(v.sLtheta.Al,nrow(v.sLtheta.Al),ncol(m.Ltheta.mrd.Al))

m.fb.il <- m.Ltheta.mrd.Al/m.sLtheta.Al

## valor esperado

v.fb.il <- cbind(apply(m.fb.il,2,sum))

# nmero esperado de indivduos em cada item
# atravs dos valores das habilidades (pontos de quadratura)

m.rb.il <- (t(m.fb.il))%*%m.Y


result.gera.dados.art.MRD <- list(m.fb.il=m.fb.il,v.fb.il=v.fb.il,m.rb.il=m.rb.il)

return(result.gera.dados.art.MRD)

} 

#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 5 - fim
#
#@@@@@@@@@@@@@@@@@@@@@@@

gera.dados5<-gera.dados.art.MRD(binario,m.Ltheta.mrd.Al)

v.fb.il<-gera.dados5$v.fb.il

m.rb.il<-gera.dados5$m.rb.il

me.zetar<-cbind(v.a,v.d,v.c)



#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 6 - inicio - PASSO E
#
#@@@@@@@@@@@@@@@@@@@@@@@


passo.E.MRD <- function(v.theta,v.Al,me.zetar,binario,I,D)

# 
# v.theta : vetor com os pontos de quadratura (q x 1)
#
# v.Al : vetor com os pesos de quadratura (q x 1)
#
# me.zetar : matriz com os parmetros dos itens (n x I)
#            componente 1 : discriminao (intercepto) (a)
# 
#            componente 2 : intercepto (dificuldade) (d)
#
#            componente 3 : acerto casual (c)
#
# binario : matriz de dados (n x I)

{

v.a <- cbind(me.zetar[,1])
v.d <- cbind(me.zetar[,2])
v.c <- cbind(me.zetar[,3])

result.passo.E.MRD <- list(v.fb.il=v.fb.il,m.rb.il=m.rb.il,m.P=m.P)

return(result.passo.E.MRD)

}

#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 6 - fim- PASSO E
#
#@@@@@@@@@@@@@@@@@@@@@@@

passoE<-passo.E.MRD(v.theta,v.Al,me.zetar,binario,I,D)

me.par0<-me.zetar


#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 7 - inicio - PASSO M
#
#@@@@@@@@@@@@@@@@@@@@@@@


passo.M.MRD <- function(binario,m.P,v.fb.il,m.rb.il,v.theta.l,I,me.par0,lia,lsa,ld)

{

S.a <- S.d <- S.c <- matrix(0,I,1) # (I x 1)

me.abc <- me.adc <- mep.abc <- mep.adc <- matrix(0,I,3) # (I x 3)

mcov.abc <- mcov.adc <- matrix(0,3*I,3) # (3*I,3)


# matriz de valores no
# passo t
me.adc0 <- me.par0

# Este lao executa o processo iterativo de
# Newton-Raphson, para cada item
iter.item <- 1


m.P.estr <- prob.tri.repar(cbind(me.par0[,1]),cbind(me.par0[,2]),matrix(0,I,1),v.theta.l,D)$m.P


m.Q.estr <- 1 - m.P.estr # probabildiade de resposta incorreta
                         # no modelo de 2 parmetros (n x I)

m.Q <- 1 - m.P # matriz de probabildiade de erro (q x 1)


#lao para a estimao por item

for (i in 1:I)

{


v.Wil <- cbind((m.P.estr[,i]*m.Q.estr[,i])/(m.P[,i]*m.Q[,i])) # pesos de Urban-Mller (q x 1)

v.Wil.estr <- cbind(m.P.estr[,i]*m.Q.estr[,i]) # ponderao sem o parmetro c (q x 1)

v.fil.Pil <- cbind(v.fb.il * m.P[,i]) # f.barra ponderado (q x 1)


# Vetor escore dos parmetros dos itens
#  Componente 1 : inclinao
#  Componente 2 : intercepto
#  Componente 3 : acerto casual

# inclinao
S.a[i] <- D*(1 - me.par0[i,3]) * sum((cbind(m.rb.il[,i]) - v.fil.Pil) * v.theta.l*v.Wil) # (1 x 1)

# intercepto
S.d[i] <- D*(1 - me.par0[i,3]) * sum((cbind(m.rb.il[,i]) - v.fil.Pil) * v.Wil) # (1 x 1)

# acerto casual
S.c[i] <- sum((cbind(m.rb.il[,i]) - v.fil.Pil)*(v.Wil/cbind(m.P.estr[,i]))) # (1 x 1)

# Construo do vetor escore completo
# concantenao horizontal

S.adc <- rbind(S.a[i],S.d[i],S.c[i]) # (3 x 1)


#  Construo da Matriz Hessiana
#  Componente 1.1 : inclinao
#  Componente 1.2 : inclinao-intercepto
#  Componente 1.3 : inclinao-acerto casual
#  Componente 2.2 : intercepto
#  Componente 2.3 : intercepto- acerto casual
#  Componente 3.3 : acerto casual 


# vetores auxiliares
v.aux1.quad <- cbind(m.rb.il[,i]) - v.fil.Pil # componente 1  (q x 1)

v.aux2.quad <- cbind(m.rb.il[,i]) - 2*cbind(m.rb.il[,i]*m.P[,i]) + v.fb.il*(cbind(m.P[,i]^2)) # componente 2 (q x 1)


# Intercepto
I.dd <- (D^2)*((1 - me.par0[i,3])^2) * sum(v.fb.il*v.Wil.estr*v.Wil) # (1 x 1)

#Inclinao
I.aa <- (D^2)*((1 - me.par0[i,3])^2) * sum(v.fb.il*v.Wil.estr*(v.theta.l^2)*v.Wil) # (1 x 1)

# Acerto casual
I.cc <- sum(v.fb.il*v.Wil*cbind(m.Q.estr[,i])/cbind(m.P.estr[,i])) # ( 1 x1)


# Inclinao-intercepto
I.ad <- (D^2)*((1 - me.par0[i,3])^2) * sum(v.fb.il*v.Wil*v.Wil.estr*(v.theta.l)) # (1 x 1)

# Inclinao - acerto casual
I.ac <- (D)*(1 - me.par0[i,3])*sum(v.theta.l * v.Wil * cbind(m.Q.estr[,i]) * v.fb.il) # (1 x 1)

# Inclinao - acerto casual
I.dc <- (D)*(1 - me.par0[i,3])*sum(v.fb.il*cbind(m.Q.estr[,i])*v.Wil) # (1 x 1)


# Construo da informao de fisher completa
# concantenao vertical e horizontal
I.adc <- matrix(rbind(cbind(I.aa,I.ad,I.ac),cbind(I.ad,I.dd,I.dc),cbind(I.ac,I.dc,I.cc)),3,3)


# Matriz de covarincia dos parmetros
i.I.adc <- solve(I.adc) # (3 x 3)



# Matriz de erros-padro dos parmetros
# componente 1 : discriminao (inclinao)
# componente 2 : dificuldade (intercepto)
# componente 3 : acerto casual

mep.adc[i,] <- rbind(sqrt(diag(i.I.adc))) # (I x 3)

#### Execuo do procedimento de Newton-Raphson

ve.adc0 <- rbind(me.adc0[i,1],me.adc0[i,2],me.adc0[i,3]) # (3 x 1)

## Processo iterativo
ve.adc <- ve.adc0 + i.I.adc %*% S.adc # (3 x 1)

## matriz para o uso do mtodo delta
m.delta <- rbind(cbind(1,0,0),cbind((ve.adc[2])/(ve.adc[1]^2),(-1)/ve.adc[1],0),cbind(0,0,1)) # (3 x 3)

# matriz de covarincias dos parmetros originais
mcov.abc<- m.delta %*% i.I.adc %*% (t(m.delta)) # (3I x 3)

# erros-padro dos parmetros originais
mep.abc[i,] <- rbind(sqrt(diag(mcov.abc))) # (I x 3)


# Matriz com as estimativas dos parmetros
#  Componente 1 : inclinao
#  Componente 2 : intercepto
#  Componente 3 : acerto casual
me.adc[i,] <- cbind(ve.adc[1],ve.adc[2],ve.adc[3]) # (I x 3)


# Obteno dos resultados para os parmatros
# originais zeta_i = (a.i,b.i,c.u)'
# matriz para o uso do mtodo delta
m.delta <- rbind(cbind(1,0,0),cbind((ve.adc[2])/(ve.adc[1]^2),(-1)/ve.adc[1],0),cbind(0,0,1)) # (3 x 3)

}

# Obteno dos parmetros de dificuldade
ve.b <- -(me.adc[2]/me.adc[1]) # (I x 1)

# clculo relativos a incrementos e atualizaes

###
### atualizao condicional
###

for (k in 1:I)

{

if (me.adc[k,1] <= lia || me.adc[k,1] >= lsa || abs(me.adc[k,2]) >= ld || me.adc[k,3] <=0 || me.adc[k,3]>=1)
{
me.par0[k,] <- me.par0[k,]
}
else
{
me.par0[k,] <- me.adc[k,]
}

}
  
aux.incre <- (rbind(cbind(me.adc[,1]),cbind(me.adc[,2]),cbind(me.adc[,3]))-
rbind(cbind(me.par0[,1]),cbind(me.par0[,2]),cbind(me.par0[,3]))) # (3I x 1)

aux.incre.1 <- rbind(cbind(me.par0[,1]),cbind(me.par0[,2]),cbind(me.par0[,3])) # (3I x 1)

prec.item <- (t(aux.incre)%*%(aux.incre))/(t(aux.incre.1)%*%(aux.incre.1)) # (1 x 1)

iter.item <- iter.item + 1

me.abc <- cbind(me.par0[,1],-(me.par0[,2]/me.par0[,1]),me.par0[,3])

result.passo.M.MRD <- list(me.par0=me.par0,mep.adc=mep.adc,prec.item=prec.item,iter.item=(iter.item-1),me.abc=me.abc,
mep.abc=mep.abc)

return(result.passo.M.MRD)

}



#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 7 - fim- PASSO M
#
#@@@@@@@@@@@@@@@@@@@@@@@

passo.M <- passo.M.MRD(binario,m.P,v.fb.il,m.rb.il,v.theta,I,me.par0,lia,lsa,ld)




#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 8 - incio 
#
#@@@@@@@@@@@@@@@@@@@@@@@

nalter2<-matrix(nalter,length(nalter),1)

algoritmo.EM.MRD <- function(binario,n.ciclo.EM,prec.item.EM,npq,limite,m.norm,var.norm,lia,lsa,ld)

{

I <- ncol(binario)

n <- nrow(binario)

me.par0<-gera.est.ini.MRD(binario,nalter2,3)$me.par.ite


###
### estimativas iniciais (CHUTES) para os parametros
###

if (chuteinicial==1)
{me.par0<- cbind(me.par0[,1],me.par0[,3],me.par0[,4])}

if (chuteinicial==2)
{me.par0<-cbind(matrix(chute.a,I,1),me.par0[,3],me.par0[,4])}

if (chuteinicial==3)
{me.par0<-cbind(matrix(chute.a,I,1),matrix(chute.b,I,1),me.par0[,4])}

if (chuteinicial==4)
{me.par0 <-cbind(rlnorm(I,lognor.media,lognor.dp),rnorm(I,0,1),me.par0[,4])}

if (chuteinicial==5)
{me.par0 <-cbind(rlnorm(I,lognor.media,lognor.dp),rnorm(I,0,1),rbeta(I,c1,c2))}

ciclo.EM <- 1

prec.item <- prec.item.EM + 1

# gera os pontos de quadratura
result.pont.quad <- gera.quad.norm.mrd(npq,limite,m.norm,var.norm)
v.theta.l <- result.pont.quad$v.pq
v.Al <- result.pont.quad$w.pq
max.iter.item <-1
crit.para.item  <- 0.01


#
# Lao
#

while(ciclo.EM <= n.ciclo.EM && prec.item > prec.item.EM)
{

# Passo E

result.passo.E.MRD <- passo.E.MRD(v.theta.l,v.Al,me.par0,binario,I,1)

m.P <- result.passo.E.MRD$m.P

v.fb.il <- result.passo.E.MRD$v.fb.il

m.rb.il <- result.passo.E.MRD$m.rb.il

# Passo M
 
result.passo.M.MRD <- passo.M.MRD(binario,m.P,v.fb.il,m.rb.il,v.theta.l,I,me.par0,lia,lsa,ld)

me.par0 <- me.adc0 <- result.passo.M.MRD$me.par0

mep.adc <- result.passo.M.MRD$mep.adc

me.abc <- result.passo.M.MRD$me.abc

mep.abc <- result.passo.M.MRD$mep.abc


prec.item <- result.passo.M.MRD$prec.item

ciclo.EM <- ciclo.EM + 1
}


result.EM <- list(me.par0=me.par0,mep.adc=mep.adc,me.abc=me.abc,mep.abc=mep.abc,prec.item=prec.item,ciclo.EM=ciclo.EM)


return(result.EM)


}

#@@@@@@@@@@@@@@@@@@@@@@@
#
# funcao 8 - fim
#
#@@@@@@@@@@@@@@@@@@@@@@@


algorit<-algoritmo.EM.MRD(binario,n.ciclo.EM,prec.item.EM,npq,limite,m.norm,var.norm,lia,lsa,ld)

abc<-algorit$me.abc

abc.ep<-algorit$mep.abc

ciclos<-algorit$ciclo.EM



#@@@@@@@@@@@@@@@@@@@@@@@
#
# saida dos dados
#
#@@@@@@@@@@@@@@@@@@@@@@@

abc<-format(round(abc, digits=3), nsmall=3)
abc.ep<-format(round(abc.ep, digits=3), nsmall=3)

# cria matriz com nomes dos itens considerados
nomes<-matrix(nc=1, nr=I)
cont<-1
for (i in 1:NIX)
{
	if(considerax[i]=="S")
	{
	nomes[cont,1]<-nomeitemx[i+1]
	cont<-cont+1
	}

}
abc<-cbind(abc,nomes)


linhas<-2*nrow(abc)+2   # numero de linhas da matriz saida

saida<-matrix(nc=4, nr=linhas)

cont<-1
contduplo<-1

for (i in 1:NIX)
{
	if (considerax[i]=="S")
	{
		saida[contduplo,1]<-nomeitemx[i+1]
		cont<-cont+1
		contduplo<-contduplo+2
	}
}



contduplo<-1
contduplob<-2

for (i in 1:nrow(abc))
{
	saida[contduplo,2]<-abc[i,1]
	saida[contduplo,3]<-abc[i,2]
	saida[contduplo,4]<-abc[i,3]
	saida[contduplob,2]<-abc.ep[i,1]
	saida[contduplob,3]<-abc.ep[i,2]
	saida[contduplob,4]<-abc.ep[i,3]
	contduplo<-contduplo+2
	contduplob<-contduplob+2

}

saidatri<-matrix(nc=4, nr=13)
saidatri[1,1]<-"Calibracao - TRI"
saidatri[1,2]<-"Teste X"
saidatri[2,1]<-"Metodo"
saidatri[2,2]<-"Max. veross."
saidatri[3,1]<-"Modelo"
saidatri[3,2]<-"Logistico"
saidatri[3,3]<-"(3 parametros)"
saidatri[4,1]<-"Ciclos EM:"
saidatri[4,2]<-ciclos
saidatri[5,1]<-"Num. itens:"
saidatri[5,2]<-I
saidatri[6,1]<-"Itens desconsider.:"
saidatri[6,2]<-NIX-I
saidatri[7,1]<-"Respondentes:"
saidatri[7,2]<-NAX

saidatri[9,1]<-"Mtodo p/'chutes':"
saidatri[9,2]<-chuteinicial

saidatri[11,1]<-"Estimativas"
saidatri[12,1]<-"(erro padrao)"
saidatri[13,1]<-"item"
saidatri[13,2]<-"discriminacao"
saidatri[13,3]<-"dificuldade"
saidatri[13,4]<-"acerto casual"

saidatri<-rbind(saidatri,saida)

# retira os NA da matriz saida

for (i in 1:length(saidatri[,1]))

{

	for (j in 1:length(saidatri[1,]))

	{

	if (is.na(saidatri[i,j])==TRUE)

		{

		saidatri[i,j]<-" "

		}

	}

}


tkdestroy(tela)

# gera arquivo final "saida-fase3-TRI-x.txt"

write.matrix(saidatri, file = "saida-fase3-TRI-x.txt", sep = " ")
write.matrix(abc, file = "parametrosx.txt", sep = ",")

# mensagem de alerta
ReturnVal <- tkmessageBox(title="Estimao - TRI",message="Os resultados da anlise esto nos arquivos 
fase3-saida-TRI-x.txt .",icon="info",type="ok")






