# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.
setwd("C:/TRI/exemplo")

# Voc deseja equalizar as habilidades (necessrio arquivos habildiadesx.txt
# e habilidadesy.txt) ? Configure "S" para sim ou "N" para no.
equahabi<-"S"

# escolha o mtodo de equalizao a posteriori: 
# 1 para mdia-desvio ou 2 para mdia-mdia
metodo<-1

# Para os parmetros dos itens comuns deve-se
# 1 - obter a mdia dos parmetros de Y com os equalizados de X
# 2 - manter os parmetros do teste Y
metcomum<-1


############################################################################################
# Equalizao a posteriori - TRI - mtodo mdia-desvio - modelo logstico com 3 parmetros
############################################################################################
# Este programa faz a equalizao dos parmetros (e habilidades) dos itens da mtrica da
# prova X para a mtrica da prova Y. Ao final,  gerado o arquivo 
# 'saida-fase4-param2testes.txt' contendo os parmetros dos testes equalizados. 
# Opcionalmente, caso seja feita a equalizao das habilidades,  gerado um arquivo 
# chamado 'saida-fase4-habil2testes.txt'.
#
# Configurao dos arquivos de entrada:
#######
# parametrosx.txt
# parametrosy.txt
#
# Esses dois arquivos devem conter em cada linha separados por vrgulas:
# nome do item, parmetro a (discriminao), parametro b (dificuldades), parametro c (acerto
# casual)
# Itens comuns (referentes ao teste NCORA) devem ter o mesmo nome. 
# O programa diferencia maisculas de minsculas. 
####### Equalizao das habilidades (opcional)
# habilidadesx.txt
# habilidadesy.txt
#
# Deve conter as habilidades dos indivduos separados por linhas.
#######
# 
# Deve estar disponvel a biblioteca 'MASS' e 'tcltk' para que o programa rode.
# Os resultados apresentados esto na mesma escala dos parmetros dos itens da prova Y.
############################################################################################
#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################


library(MASS)
require(tcltk)
library(tcltk)

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );


infoprovax<-read.table("entradax.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")
NIX<-length(infoprovax[1,])-1 

respostax<-scan(file="entradax.txt", sep=",", skip=3, what=list(""),n=length(NIX))
nomesitensx<-respostax[[1]]  # vetor que contm os nomes dos itens da prova X

respostax<-scan(file="entradax.txt", sep=",", skip=2, what=list(""),n=length(NIX))
considerax<-respostax[[1]]  # considera (S) ou desconsidera(N) o item

cont<-0
for (i in 1:NIX)
{
	if (considerax[i]=="S")
	{
		if(cont==0)
		{nomesx<-c(nomesitensx[i+1])
		cont<-1}
		else
		{nomesx<-c(nomesx,nomesitensx[i+1])}
	}
}

param<-scan(file="parametrosx.txt", sep=",", what=list(0,0,0,""))
par.ax<-param[[1]]  # vetor que contm os parametros a da prova X
par.bx<-param[[2]]  # vetor que contm os parametros b da prova X
par.cx<-param[[3]]  # vetor que contm os parametros c da prova X



infoprovay<-read.table("entraday.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")
NIY<-length(infoprovay[1,])-1

respostay<-scan(file="entraday.txt", sep=",", skip=3, what=list(""),n=length(NIY))
nomesitensy<-respostay[[1]]  # vetor que contm os nomes dos itens da prova Y

respostay<-scan(file="entraday.txt", sep=",", skip=2, what=list(""),n=length(NIY))
consideray<-respostay[[1]]  # considera (S) ou desconsidera(N) o item


cont<-0
for (i in 1:NIY)
{
	if (consideray[i]=="S")
	{
		if(cont==0)
		{nomesy<-c(nomesitensy[i+1])
		cont<-1}
		else
		{nomesy<-c(nomesy,nomesitensy[i+1])}
	}
}


paramy<-scan(file="parametrosy.txt", sep=",", what=list(0,0,0,""))
par.ay<-paramy[[1]]  # vetor que contm os parametros a da prova Y
par.by<-paramy[[2]]  # vetor que contm os parametros b da prova Y
par.cy<-paramy[[3]]  # vetor que contm os parametros c da prova Y



if(equahabi=="S")
{
habil<-scan(file="habilidadesx.txt", sep=",", what=list(0))
habilidadesx<-habil[[1]]  # vetor que contm as habilidades dos alunos que fizeram o teste X
habil<-scan(file="habilidadesy.txt", sep=",", what=list(0))
habilidadesy<-habil[[1]]  # vetor que contm as habilidades dos alunos que fizeram o teste Y
}

# nmero de itens considerados
NIXc<-length(nomesx)
NIYc<-length(nomesy)


### localiza os itens comuns em cada uma das provas e cria vetor com essas posies

# poscomumx = posio dos itens comuns na prova x

# poscomumy = posio dos itens comuns na prova y



contcomum<-0  # conta o nmero de itens comuns



for (i in 1:NIXc)

{

	for(j in 1:NIYc)

	{

		if(nomesx[i]==nomesy[j])

		{
				if(contcomum==0)

				{

				poscomumx<-c(i)

				poscomumy<-c(j)
				}

				else

				{

				poscomumx<-c(poscomumx,i)

				poscomumy<-c(poscomumy,j)
				}
				contcomum<-contcomum+1
		}

	}

}


if (contcomum==0)

{

print("*** ERRO ***")

print("Nao foram encontrados itens comuns.")

print("Nao e' possivel realizar a equalizacao!")

print("Verifique se aos itens comuns foram atribuidos mesmo nome.")

ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="ERRO!
No foram encontrados itens comuns.
No  possivel realizar a equalizao!
Verifique se aos itens comuns foram atribudos mesmo nome.",icon="warning",type="ok")
}


### cria vetores com os parametros comuns

for (t in 1:contcomum)
{
	if (t==1)
	{
	comum.ax<-c(par.ax[poscomumx[t]])
	comum.ay<-c(par.ay[poscomumy[t]])
	comum.bx<-c(par.bx[poscomumx[t]])
	comum.by<-c(par.by[poscomumy[t]])
	comum.nomes<-c(nomesx[poscomumx[t]])
	}
	else
	{
	comum.ax<-c(comum.ax,par.ax[poscomumx[t]])
	comum.ay<-c(comum.ay,par.ay[poscomumy[t]])
	comum.bx<-c(comum.bx,par.bx[poscomumx[t]])
	comum.by<-c(comum.by,par.by[poscomumy[t]])
	comum.nomes<-c(comum.nomes,nomesx[poscomumx[t]])
	}
}

### calcula mdias e desvios-padres 

media.ax<-mean(comum.ax)
media.ay<-mean(comum.ay)
media.bx<-mean(comum.bx)
media.by<-mean(comum.by)
desvio.bx<-sqrt(var(comum.bx))
desvio.by<-sqrt(var(comum.by))

### calculo de alfa e beta
if(metodo==1)
{
alfa<-desvio.by/desvio.bx
beta<-media.by-alfa*media.bx
}

if(metodo==2)
{
alfa<-media.ax/media.ay
beta<-media.by-alfa*media.bx
}

### cria matrizes com valores equalizados
resultx<-matrix(nc=4, nr=NIXc-contcomum)
resulty<-matrix(nc=4, nr=NIYc-contcomum)
resultc<-matrix(nc=4, nr=contcomum)

cont<-1
for (i in 1:NIXc)
{
	tipo<-"NAOCOMUM"
	for (k in 1:length(poscomumx))
	{
		if(i==poscomumx[k])
		{tipo<-"COMUM"}
	}

	if(tipo=="NAOCOMUM")
	{	
		resultx[cont,1]<-nomesx[i]
		resultx[cont,2]<-format(round(par.ax[i]/alfa, digits=3), nsmall=3)
		resultx[cont,3]<-format(round(alfa*par.bx[i]+beta, digits=3), nsmall=3)
		resultx[cont,4]<-format(round(par.cx[i], digits=3), nsmall=3)
		cont<-cont+1
	}
}


cont<-1
for (i in 1:NIYc)
{
	tipo<-"NAOCOMUM"
	for (k in 1:length(poscomumy))
	{
		if(i==poscomumy[k])
		{tipo<-"COMUM"}
	}

	if(tipo=="NAOCOMUM")
	{	
		resulty[cont,1]<-nomesy[i]
		resulty[cont,2]<-format(round(par.ay[i], digits=3), nsmall=3)
		resulty[cont,3]<-format(round(par.by[i], digits=3), nsmall=3)
		resulty[cont,4]<-format(round(par.cy[i], digits=3), nsmall=3)
		cont<-cont+1
	}
}


# gerao de vetores para construcao dos graficos dos paramteros

graf.ax<-rep(0, NIXc-contcomum)
graf.ay<-rep(0, NIYc-contcomum)
graf.bx<-rep(0, NIXc-contcomum)
graf.by<-rep(0, NIYc-contcomum)
for (k in 1:contcomum)
{
	graf.ax[k]<-par.ax[poscomumx[k]]
	graf.ay[k]<-par.ay[poscomumx[k]]
	graf.bx[k]<-par.bx[poscomumy[k]]
	graf.by[k]<-par.by[poscomumy[k]]
	
}
# cria arquivo com os grficos

jpeg(filename = "saida-fase4-graf.jpg", width = 350, height = 500,pointsize = 12, quality = 75, bg = "white")

par(mfcol=c(2,1))
plot(graf.ax,graf.ay,xlab="Teste X", ylab="Teste Y", main="Parmetro a - itens comuns")
plot(graf.bx,graf.by,xlab="Teste X", ylab="Teste Y", main="Parmetro b - itens comuns")
dev.off()





if (metcomum==1)
{
	for (k in 1:contcomum)
	{
		resultc[k,1]<-nomesy[poscomumy[k]]
		resultc[k,2]<-format(round((par.ay[poscomumy[k]]+(par.ax[poscomumx[k]]/alfa))/2, digits=3), nsmall=3)
		resultc[k,3]<-format(round((par.by[poscomumy[k]]+(alfa*par.bx[poscomumx[k]]+beta))/2, digits=3), nsmall=3)
		resultc[k,4]<-format(round(par.cy[poscomumy[k]], digits=3), nsmall=3)
	}
}


if (metcomum==2)
{
	for (k in 1:contcomum)
	{
		resultc[k,1]<-nomesy[poscomumy[k]]
		resultc[k,2]<-format(round(par.ay[poscomumy[k]], digits=3), nsmall=3)
		resultc[k,3]<-format(round(par.by[poscomumy[k]], digits=3), nsmall=3)
		resultc[k,4]<-format(round(par.cy[poscomumy[k]], digits=3), nsmall=3)
	}
}

# ordenao alfabtica

resultpar2<-resultx
resultpar2<-rbind(resultpar2,resulty)
resultpar2<-rbind(resultpar2,resultc)
ordem<-c(resultpar2[,1])
ordem<-sort(ordem)
resultpar3<-matrix(nc=ncol(resultpar2), nr=nrow(resultpar2))
for (i in 1:nrow(resultpar2))
{
	for (linha in 1:nrow(resultpar2))
	{
		if(ordem[i]==resultpar2[linha,1]) {pos<-linha}
	}
	resultpar3[i,1]<-resultpar2[pos,1]
	resultpar3[i,2]<-resultpar2[pos,2]
	resultpar3[i,3]<-resultpar2[pos,3]
	resultpar3[i,4]<-resultpar2[pos,4]
}



# matriz de saida

resultpar<-matrix(nc=4, nr=25)
resultpar[1,1]<-"Parametros"
resultpar[1,2]<-"equalizados"
resultpar[1,3]<-"- TRI"
resultpar[2,1]<-"Modelo com"
resultpar[2,2]<-"3 parametros"

resultpar[3,1]<-"Metodo:"
if (metodo==1) {resultpar[3,2]<-"Media-desvio"}
if (metodo==2) {resultpar[3,2]<-"Media-media"}

resultpar[5,1]<-"Estatisticas -"
resultpar[6,1]<-"------------"
resultpar[5,2]<-"itens comuns"
resultpar[6,2]<-"Teste X"
resultpar[6,3]<-"Teste Y"
resultpar[7,1]<-"Media (a)"
resultpar[7,2]<-format(round(media.ax, digits=3),nsmall=3)
resultpar[7,3]<-format(round(media.ay, digits=3),nsmall=3)
resultpar[8,1]<-"Media (b)"
resultpar[8,2]<-format(round(media.bx, digits=3),nsmall=3)
resultpar[8,3]<-format(round(media.by, digits=3),nsmall=3)
resultpar[9,1]<-"Desvio-padrao (b)"
resultpar[9,2]<-format(round(desvio.bx, digits=3),nsmall=3)
resultpar[9,3]<-format(round(desvio.by, digits=3),nsmall=3)

resultpar[11,1]<-"alfa:"
resultpar[11,2]<-format(round(alfa, digits=3),nsmall=3)
resultpar[12,1]<-"beta:"
resultpar[12,2]<-format(round(beta, digits=3),nsmall=3)

resultpar[14,1]<-"Itens considerados"
resultpar[15,1]<-"------------------"
resultpar[16,1]<-"Teste X:"
resultpar[16,2]<-NIXc
resultpar[17,1]<-"Teste Y:"
resultpar[17,2]<-NIYc
resultpar[18,1]<-"Comuns:"
resultpar[18,2]<-contcomum

resultpar[20,1]<-"Equalizacao"
resultpar[21,1]<-"-----------"

resultpar[23,2]<-"discriminacao"
resultpar[23,3]<-"dificuldade"
resultpar[23,4]<-"acerto casual"
resultpar[24,1]<-"Item"
resultpar[24,2]<-"    (a)"
resultpar[24,3]<-"    (b)"
resultpar[24,4]<-"     (c)"

resultpar<-rbind(resultpar,resultpar3)


# retira os NA da matriz saida
for (i in 1:length(resultpar[,1]))
{
	for (j in 1:length(resultpar[1,]))
	{
	if (is.na(resultpar[i,j])==TRUE)
		{
		resultpar[i,j]<-" "
		}
	if (resultpar[i,j]=="NA")
		{
		resultpar[i,j]<-" "
		}
	}
}



if (equahabi=="S")
{

habilidadesx<-habilidadesx*alfa+beta
saidahabx<-matrix(nc=2, nr=7+length(habilidadesx))
saidahabx[1,1]<-"Habilidades equalizadas"
saidahabx[2,1]<-"Metodo:"
if (metodo==1) {saidahabx[2,2]<-"Media-desvio"}
if (metodo==2) {saidahabx[2,2]<-"Media-media"}
saidahabx[4,1]<-"Individuos - teste X"
saidahabx[5,1]<-"--------------------"

	for (i in 1:length(habilidadesx))
	{
	saidahabx[i+5,1]<-format(round(habilidadesx[i], digits=3), nsmall=3)
	}

saidahaby<-matrix(nc=2, nr=5+length(habilidadesy))
saidahaby[3,1]<-"Individuos - teste Y"
saidahaby[4,1]<-"--------------------"

	for (i in 1:length(habilidadesy))
	{
	saidahaby[i+4,1]<-format(round(habilidadesy[i], digits=3), nsmall=3)
	}

saidahabx<-rbind(saidahabx,saidahaby)

# retira os NA da matriz saida
for (i in 1:length(saidahabx[,1]))
{
	for (j in 1:length(saidahabx[1,]))
	{
	if (is.na(saidahabx[i,j])==TRUE)
		{
		saidahabx[i,j]<-" "
		}
	}
}

# gera arquivo final "saida-fase4-habil2testes.txt"
write.matrix(saidahabx, file = "saida-fase4-habil2testes.txt", sep = " ")

}

tkdestroy(tela)

# gera arquivo final "saida-fase4-param2testes.txt"
write.matrix(resultpar, file = "saida-fase4-param2testes.txt", sep = " ")


# gera janela de aviso
if(equahabi=="N")
{
ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="Os resultados da anlise esto no arquivo 
saida-fase4-param2testes.txt.",icon="info",type="ok")
} 

if(equahabi=="S")
{
ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="Os resultados da anlise esto nos arquivos 
saida-fase4-param2testes.txt e 
saida-fase4-habil2testes.txt .",icon="info",type="ok")
} 



