# Configure o local onde esto os arquivos e onde ser gravado o arquivo de sada.
setwd("C:/TRI/exemplo")

# Voc deseja equalizar as habilidades (necessrio arquivos habilidadesx.txt)?
# Configure "S" para sim ou "N" para no.
equahabi<-"N"

# escolha o mtodo de equalizao a posteriori: 
# 1 para mdia-desvio ou 2 para mdia-mdia
metodo<-1

# Valor da mdia do parmetros de discriminao (a) da mtrica pr-definida
# (necessrio apenas no mtodo mdia-mdia; caso o mtodo escolhido seja
# mdia-desvio, deixar qualquer valor no campo abaixo).
media.apd<-1

# Valor da mdia do parmetros de dificuldade (b) da mtrica pr-definida
media.bpd<-0.5

# valor do desvio-padro da mtrica pr-definida
# (necessrio apenas no mtodo mdia-desvio; caso o mtodo escolhido seja
# mdia-mdia, deixar qualquer valor no campo abaixo).
dp.bpd<-1


############################################################################################
# Equalizao a posteriori - TRI - mtodo mdia-desvio - modelo logstico com 3 parmetros
# transforma mtrica dos itens de 1 prova - Teste X
############################################################################################
# Este programa faz a equalizao dos parmetros (e habilidades) dos itens da mtrica da
# prova X para uma mtrica pr-definida (mdia e desvio-padro).
#
# Ao final  gerado o arquivo 'saida-fase4-param-escala-x.txt' com os resultados da
# equalizao dos parmetros. Opcionalmente pode ser gerado o arquivo com as habilidades
# equalizadas ('saida-fase4-habil-escala-x.txt').
#
# Configurao dos arquivos de entrada:
#######
# parametrosx.txt
#
# Esse arquivo deve conter, em cada linha, separado por vrgulas:
# nome do item, parmetro a (discriminao), parametro b (dificuldades), parametro c (acerto
# casual)
# Itens comuns (referentes ao teste NCORA) devem ter o mesmo nome. 
# O programa diferencia maisculas de minsculas. 
####### Equalizao das habilidades (opcional)
# habilidadesx.txt
#
# Deve conter as habilidades dos indivduos separados por linhas.
#######
# itenscomunsx.txt
#
# Deve conter os nomes dos itens comuns separados por vrgulas.
#######
# 
# Deve estar disponvel a biblioteca 'MASS' e 'tcltk' para que o programa rode.
# Os resultados apresentados esto na mesma escala dos parmetros dos itens da prova Y.
############################################################################################
#	***  NO ALTERAR NADA DESTE PONTO EM DIANTE! ***

############################################################################################



library(MASS)
require(tcltk)
library(tcltk)

ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="Lembre-se de criar/configurar o 
arquivo 'itenscomunsx.txt' que contm 
os nomes dos itens comuns.",icon="info",type="ok")

# Cria a tela do programa
tela <- tktoplevel()
tkgrid( tklabel(tela, text=""), columnspan=1 );
tkgrid( tklabel(tela, text="   Aguarde processamento...   "), columnspan=1 );
tkgrid( tklabel(tela, text=""), columnspan=1 );


infoprovax<-read.table("entradax.txt", header=FALSE, fill=TRUE, nrows=3,sep=",")
NIX<-length(infoprovax[1,])-1 

respostax<-scan(file="entradax.txt", sep=",", skip=3, what=list(""),n=length(NIX))
nomesitensx<-respostax[[1]]  # vetor que contm os nomes dos itens da prova X

respostax<-scan(file="entradax.txt", sep=",", skip=2, what=list(""),n=length(NIX))
considerax<-respostax[[1]]  # considera (S) ou desconsidera(N) o item

cont<-0
for (i in 1:NIX)
{
	if (considerax[i]=="S")
	{
		if(cont==0)
		{nomesx<-c(nomesitensx[i+1])
		cont<-1}
		else
		{nomesx<-c(nomesx,nomesitensx[i+1])}
	}
}

param<-scan(file="parametrosx.txt", sep=",", what=list(0,0,0,""))
par.ax<-param[[1]]  # vetor que contm os parametros a da prova X
par.bx<-param[[2]]  # vetor que contm os parametros b da prova X
par.cx<-param[[3]]  # vetor que contm os parametros c da prova X

param<-scan(file="itenscomunsx.txt", sep=",", what=list(""))
icomum<-param[[1]]  # vetor que contm os nomes dos itens da prova X



if(equahabi=="S")
{
habil<-scan(file="habilidadesx.txt", sep=",", what=list(0))
habilidadesx<-habil[[1]]  # vetor que contm as habilidades dos alunos que fizeram o teste X
}

NIXc<-length(nomesx)
NIC<-length(icomum)

### localiza os itens comuns em cada uma das provas e cria vetor com essas posies

# poscomumx = posio dos itens comuns na prova x



contcomum<-0  # conta o nmero de itens comuns



for (i in 1:NIXc)

{

	for(j in 1:NIC)

	{

		if(nomesx[i]==icomum[j])

		{


				if(contcomum==0)

				{

				poscomumx<-c(i)

				poscomumy<-c(j)
				}

				else

				{

				poscomumx<-c(poscomumx,i)

				poscomumy<-c(poscomumy,j)
				}
				contcomum<-contcomum+1
		}

	}

}


if (contcomum==0)

{

print("*** ERRO ***")

print("Nao foram encontrados itens comuns.")

print("Nao e' possivel realizar a equalizacao!")

print("Verifique se aos itens comuns foram atribuidos mesmo nome.")
ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="ERRO!
No foram encontrados itens comuns.
No  possivel realizar a equalizao!
Verifique se aos itens comuns foram atribudos mesmo nome.",icon="warning",type="ok")
}

if(length(icomum)!=contcomum)
{
print("*** ERRO ***")

print("Numero de itens comuns no arquivo itenscomunsx.txt")
print("eh diferente dos itens encontrados no arquivo entradax.txt.")

print("Verifique se os nomes dos itens nesses arquivos estao corretos.")
ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="ERRO!
Nmero de itens comuns no arquivo itenscomunsx.txt
 diferente dos itens encontrados no arquivo entradax.txt.
Verifique se os nomes dos itens nesses arquivos esto corretos.",icon="warning",type="ok")
}


### cria vetores com os parametros comuns

for (t in 1:contcomum)
{
	if (t==1)
	{
	comum.ax<-c(par.ax[poscomumx[t]])
	comum.bx<-c(par.bx[poscomumx[t]])
	}
	else
	{
	comum.ax<-c(comum.ax,par.ax[poscomumx[t]])
	comum.bx<-c(comum.bx,par.bx[poscomumx[t]])
	}
}

### calcula mdias e desvios-padres 

media.ax<-mean(comum.ax)
media.ay<-media.apd
media.bx<-mean(comum.bx)
media.by<-media.bpd
desvio.bx<-sqrt(var(comum.bx))
desvio.by<-dp.bpd

### calculo de alfa e beta
if(metodo==1)
{
alfa<-desvio.by/desvio.bx
beta<-media.by-alfa*media.bx
}

if(metodo==2)
{
alfa<-media.ax/media.ay
beta<-media.by-alfa*media.bx
}

### cria matrizes com valores equalizados
resultx<-matrix(nc=4, nr=NIX)

cont<-1
for (i in 1:NIX)
{
	resultx[cont,1]<-nomesx[i]
	resultx[cont,2]<-format(round(par.ax[i]/alfa, digits=3), nsmall=3)
	resultx[cont,3]<-format(round(alfa*par.bx[i]+beta, digits=3), nsmall=3)
	resultx[cont,4]<-format(round(par.cx[i], digits=3), nsmall=3)
	cont<-cont+1
}


resultpar<-matrix(nc=4, nr=19)
resultpar[1,1]<-"Parametros"
resultpar[1,2]<-"equalizados"
resultpar[1,3]<-"- TRI"
resultpar[1,4]<-"Teste X"
resultpar[2,1]<-"Modelo com"
resultpar[2,2]<-"3 parametros"

resultpar[3,1]<-"Metodo:"
if (metodo==1) {resultpar[3,2]<-"Media-desvio"}
if (metodo==2) {resultpar[3,2]<-"Media-media"}

resultpar[5,1]<-"Num.itens consid."
resultpar[6,1]<-"----------------"
resultpar[7,1]<-"Teste X:"
resultpar[7,2]<-length(nomesx)
resultpar[8,1]<-"Comuns:"
resultpar[8,2]<-length(icomum)

resultpar[10,1]<-"Escala"
resultpar[11,1]<-"------"

if (metodo==1) 
{
resultpar[12,1]<-"Media b:"
resultpar[12,2]<-media.bpd
resultpar[13,1]<-"Desvio b:"
resultpar[13,2]<-dp.bpd
}

if (metodo==2) 
{
resultpar[12,1]<-"Media a:"
resultpar[12,2]<-media.apd
resultpar[13,1]<-"Media b:"
resultpar[13,2]<-media.bpd
}



resultpar[15,1]<-"Equalizao"
resultpar[16,1]<-"-----------"

resultpar[17,1]<-"Nome do"
resultpar[17,2]<-"discriminacao"
resultpar[17,3]<-"dificuldade"
resultpar[17,4]<-"acerto casual"
resultpar[18,1]<-"Item"
resultpar[18,2]<-"a"
resultpar[18,3]<-"b"
resultpar[18,4]<-"c"

resultpar<-rbind(resultpar,resultx)

# retira os NA da matriz saida
for (i in 1:length(resultpar[,1]))
{
	for (j in 1:length(resultpar[1,]))
	{
	if (is.na(resultpar[i,j])==TRUE)
		{
		resultpar[i,j]<-" "
		}
	if (resultpar[i,j]=="NA")
		{
		resultpar[i,j]<-" "
		}
	}
}




if (equahabi=="S")
{

habilidadesx<-habilidadesx*alfa+beta
saidahabx<-matrix(nc=2, nr=7+length(habilidadesx))
saidahabx[1,1]<-"Habilidades equalizadas"
saidahabx[2,1]<-"               Metodo:"
if (metodo==1) {saidahabx[2,2]<-"Media-desvio"}
if (metodo==2) {saidahabx[2,2]<-"Media-media"}
saidahabx[4,1]<-"Individuos - teste X"
saidahabx[5,1]<-"--------------------"

	for (i in 1:length(habilidadesx))
	{
	saidahabx[i+5,1]<-format(round(habilidadesx[i], digits=3), nsmall=3)
	}


# retira os NA da matriz saida
for (i in 1:length(saidahabx[,1]))
{
	for (j in 1:length(saidahabx[1,]))
	{
	if (is.na(saidahabx[i,j])==TRUE)
		{
		saidahabx[i,j]<-" "
		}
	}
}

# gera arquivo final "saida-fase4-habil-escala.txt"
write.matrix(saidahabx, file = "saida-fase4-habil-escala-x.txt", sep = " ")

}


# gera arquivo final "saida-fase4-param-escala-x.txt"
write.matrix(resultpar, file = "saida-fase4-param-escala-x.txt", sep = " ")

tkdestroy(tela)

# gera janela de aviso
if(equahabi=="N")
{
ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="Os resultados da anlise esto no arquivo 
saida-fase4-param-escala-x.txt.",icon="info",type="ok")
} 

if(equahabi=="S")
{
ReturnVal <- tkmessageBox(title="Equalizao - TRI",message="Os resultados da anlise esto nos arquivos 
saida-fase4-param-escala-x.txt e 
saida-fase4-habil-escala-x.txt .",icon="info",type="ok")
} 
